﻿using System;
using System.Collections;
using System.Windows.Forms;

namespace CustomControls
{
    class ExtendedListViewItemComparator : IComparer
    {
        private SortOrder m_Order;
        private int m_ColumnIndex;
        private CaseInsensitiveComparer m_Comparer;

        public ExtendedListViewItemComparator()
        {
            this.Order = SortOrder.Ascending;
            this.m_Comparer = new CaseInsensitiveComparer();
        }

        public SortOrder Order
        {
            get
            {
                return this.m_Order;
            }

            set
            {
                this.m_Order = value;
            }
        }

        public int ColumnIndex
        {
            get
            {
                return this.m_ColumnIndex;
            }

            set
            {
                this.m_ColumnIndex = value;
            }
        }

        #region IComparer Members

        public int Compare(object x, object y)
        {
            int result;
            string value1 = string.Empty;
            string value2 = string.Empty;
            ListViewItem listViewItem1 = (ListViewItem)x;
            if (listViewItem1.SubItems.Count > this.ColumnIndex)
            {
                value1 = listViewItem1.SubItems[this.ColumnIndex].Text;
            }
            ListViewItem listViewItem2 = (ListViewItem)y;
            if (listViewItem2.SubItems.Count > this.ColumnIndex)
            {
                value2 = listViewItem2.SubItems[this.ColumnIndex].Text;
            }
            result = this.m_Comparer.Compare(value1, value2);
            if (this.Order == SortOrder.Descending)
            {
                result *= -1;
            }
            return result;
        }

        #endregion
    }
}
