﻿using System;
using System.Collections.Generic;

namespace CustomControls
{
    public class VirtualModeCache : List<FourStateListViewItem>
    {
        public delegate void VirtualModeCacheItemAddedHandler(object sender, EventArgs args);
        public event VirtualModeCacheItemAddedHandler ItemAdded;

        public new void Add(FourStateListViewItem item)
        {
            base.Add(item);
            this.OnItemAdded(new EventArgs());
        }

        public new void AddRange(IEnumerable<FourStateListViewItem> collection)
        {
            base.AddRange(collection);
            this.OnItemAdded(new EventArgs());
        }

        protected virtual void OnItemAdded(EventArgs e)
        {
            if (this.ItemAdded != null)
                this.ItemAdded(this, e);
        }
    }
}
