﻿using System;
using System.Windows.Forms;
using System.ComponentModel;
using System.Drawing;

namespace CustomControls
{
    [ToolboxBitmap(typeof(System.Windows.Forms.RichTextBox))]
    public class ExtendedRichTextBox : RichTextBox
    {
        private const int WM_PAINT = 0xF;

        public ExtendedRichTextBox() : base()
        {
        }

        protected override void WndProc(ref Message m)
        {
            if (m.Msg == WM_PAINT)
            {
                this.BackColor = System.Drawing.SystemColors.Window;
                if (this.ReadOnly)
                {
                    this.BackColor = System.Drawing.SystemColors.Control;
                }
            }
            base.WndProc(ref m);
        }
    }
}
