﻿using System;
using System.Windows.Forms;
using System.Drawing;
using System.ComponentModel;
using System.ComponentModel.Design;

namespace CustomControls
{
    [Designer(typeof(ExtendedTabPageControlDesigner), typeof(IDesigner))]
    public class ExtendedTabPage : TabPage, ITabPage
    {
        private bool m_Selectable;
        private Panel m_PanelItems;

        public ExtendedTabPage()
        {
            this.m_Selectable = true;
            //panelItems
            this.m_PanelItems = new Panel();
            this.m_PanelItems.Dock = DockStyle.Fill;
            this.m_PanelItems.BorderStyle = BorderStyle.None;
            this.Controls.Add(this.m_PanelItems);
            //bring panelItems to front
            this.m_PanelItems.BringToFront();
        }

        //Is this tabpage selectable
        [Browsable(true), DefaultValue(true), Category("Misc"), Description("Is this tabpage selectable")]
        public bool Selectable
        {
            get
            {
                return this.m_Selectable;
            }
            set
            {
                this.SetSelectable(value);
            }
        }

        //expose panel internal to the ExtendedTabPageControlDesigner
        [Browsable(false)]
        [DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
        public Panel Items
        {
            get
            {
                return this.m_PanelItems;
            }
        }

        private void SetSelectable(bool value)
        {
            this.m_Selectable = value;
            this.m_PanelItems.Enabled = value;
        }
    }
}
