﻿Option Strict On
Option Explicit On
Option Infer Off

<Serializable()> _
Public Class Employee
    Inherits AbstractEmployee
    Implements IDeepClone(Of Employee)
    Private m_Department As String
    Private m_SubDepartment As String
    Private m_Title As String
    Private m_Active As String

    Public Overridable Property Department() As String
        Get
            Return m_Department
        End Get
        Set(ByVal value As String)
            m_Department = value
        End Set
    End Property

    Public Overridable Property SubDepartment() As String
        Get
            Return m_SubDepartment
        End Get
        Set(ByVal value As String)
            m_SubDepartment = value
        End Set
    End Property

    Public Overridable Property Title() As String
        Get
            Return m_Title
        End Get
        Set(ByVal value As String)
            m_Title = value
        End Set
    End Property

    'leave this property private
    'it's only purpose is to allow the creation of the query statement
    Private ReadOnly Property Active() As String
        Get
            Return m_Active
        End Get
    End Property

    Public Overridable Function DeepClone() As Employee Implements IDeepClone(Of Employee).DeepClone
        Dim clonedEmployee As Employee = New Employee()
        clonedEmployee.EmployeeId = EmployeeId
        clonedEmployee.Name = Name
        clonedEmployee.SirName = SirName
        clonedEmployee.Department = Department
        clonedEmployee.SubDepartment = SubDepartment
        clonedEmployee.Title = Title
        Return clonedEmployee
    End Function
End Class
