﻿Option Strict On
Option Explicit On
Option Infer Off

<Serializable()> _
Public Class Milestone
    Implements IDeepClone(Of Milestone)
    Private m_Id As Integer
    Private m_Name As String
    Private m_Description As String
    Private m_BeginDate As DateTime
    Private m_EndDate As DateTime

    Public Sub New()
        Id = -1
        BeginDate = Now
        EndDate = Now
    End Sub

    Public Overridable Property Id() As Integer
        Get
            Return m_Id
        End Get
        Set(ByVal value As Integer)
            m_Id = value
        End Set
    End Property

    Public Overridable Property Name() As String
        Get
            Return m_Name
        End Get
        Set(ByVal value As String)
            m_Name = value
        End Set
    End Property

    Public Overridable Property Description() As String
        Get
            Return m_Description
        End Get
        Set(ByVal value As String)
            m_Description = value
        End Set
    End Property

    Public Overridable Property BeginDate() As DateTime
        Get
            Return m_BeginDate
        End Get
        Set(ByVal value As DateTime)
            m_BeginDate = value
        End Set
    End Property

    Public Overridable Property EndDate() As DateTime
        Get
            Return m_EndDate
        End Get
        Set(ByVal value As DateTime)
            m_EndDate = value
        End Set
    End Property

    Public Function DeepClone() As Milestone Implements IDeepClone(Of Milestone).DeepClone
        Dim clonedMilestone As Milestone = New Milestone()
        clonedMilestone.Id = Id
        clonedMilestone.Name = Name
        clonedMilestone.Description = Description
        clonedMilestone.BeginDate = New DateTime(BeginDate.Ticks)
        clonedMilestone.EndDate = New DateTime(EndDate.Ticks)
        Return clonedMilestone
    End Function
End Class
