﻿Option Strict On
Option Explicit On
Option Infer Off

<Serializable()> _
Public Class RevisionStatusLine
    Implements IDeepClone(Of RevisionStatusLine), IIdentifier
    Private m_Id As Integer
    Private m_MajorRevision As Integer
    Private m_MinorRevision As Integer
    Private m_MinorSubRevision As Integer
    Private m_Description As String
    Private m_RevisedBy As String
    Private m_DateModified As DateTime
    Private m_RevisionStatus As RevisionStatus

    Public Sub New()
        Id = -1
        MajorRevision = 1
        RevisionStatus = New RevisionStatus()
    End Sub

    Public Overridable Property Id() As Integer Implements IIdentifier.Id
        Get
            Return m_Id
        End Get
        Set(ByVal value As Integer)
            m_Id = value
        End Set
    End Property

    Public Overridable Property MajorRevision() As Integer
        Get
            Return m_MajorRevision
        End Get
        Set(ByVal value As Integer)
            m_MajorRevision = value
        End Set
    End Property

    Public Overridable Property MinorRevision() As Integer
        Get
            Return m_MinorRevision
        End Get
        Set(ByVal value As Integer)
            m_MinorRevision = value
        End Set
    End Property

    Public Overridable Property MinorSubRevision() As Integer
        Get
            Return m_MinorSubRevision
        End Get
        Set(ByVal value As Integer)
            m_MinorSubRevision = value
        End Set
    End Property

    Public Overridable Property Description() As String
        Get
            Return m_Description
        End Get
        Set(ByVal value As String)
            m_Description = value
        End Set
    End Property

    Public Overridable Property RevisedBy() As String
        Get
            Return m_RevisedBy
        End Get
        Set(ByVal value As String)
            m_RevisedBy = value
        End Set
    End Property

    Public Overridable Property DateModified() As DateTime
        Get
            Return m_DateModified
        End Get
        Set(ByVal value As DateTime)
            m_DateModified = value
        End Set
    End Property

    Public Overridable Property RevisionStatus() As RevisionStatus
        Get
            Return m_RevisionStatus
        End Get
        Set(ByVal value As RevisionStatus)
            m_RevisionStatus = value
        End Set
    End Property

    Public Overridable ReadOnly Property RevisionNumber() As String
        Get
            Return String.Format("{0}.{1}.{2}", MajorRevision.ToString(), MinorRevision.ToString(), MinorSubRevision.ToString())
        End Get
    End Property

    Public Function DeepClone() As RevisionStatusLine Implements IDeepClone(Of RevisionStatusLine).DeepClone
        DeepClone = New RevisionStatusLine()
        DeepClone.Id = Id
        DeepClone.Description = Description
        DeepClone.MajorRevision = MajorRevision
        DeepClone.MinorRevision = MinorRevision
        DeepClone.MinorSubRevision = MinorSubRevision
        DeepClone.DateModified = New DateTime(DateModified.Ticks)
        DeepClone.RevisionStatus = RevisionStatus.DeepClone()
    End Function
End Class
