﻿Option Strict On
Option Explicit On
Option Infer Off

<Serializable()> _
Public Class SubCategory
    Implements IDeepClone(Of SubCategory)
    Private m_Id As Integer
    Private m_Description As String
    Private m_Category As Category

    Public Sub New()
        Id = -1
        m_Category = New Category()
    End Sub

    Public Overridable Property Id() As Integer
        Get
            Return m_Id
        End Get
        Set(ByVal value As Integer)
            m_Id = value
        End Set
    End Property

    Public Overridable Property Description() As String
        Get
            Return m_Description
        End Get
        Set(ByVal value As String)
            m_Description = value
        End Set
    End Property

    Public Overridable Property Category() As Category
        Get
            Return m_Category '.DeepClone()
        End Get
        Set(ByVal value As Category)
            m_Category = value '.DeepClone()
        End Set
    End Property

    Public Overridable Function DeepClone() As SubCategory Implements IDeepClone(Of SubCategory).DeepClone
        Dim clonedSubCategory As SubCategory = New SubCategory()
        clonedSubCategory.Id = Id
        clonedSubCategory.Description = Description
        clonedSubCategory.Category = Category.DeepClone()
        Return clonedSubCategory
    End Function
End Class
