﻿Option Strict On
Option Explicit On
Option Infer Off

<Serializable()> _
Public Class TeamMember
    'Implements IIdentifier
    Implements IDeepClone(Of TeamMember), IIdentifier
    Private m_Id As Integer
    Private m_EmployeeId As String
    Private m_EmployeeName As String
    Private m_Department As String
    Private m_SubDepartment As String
    Private m_EmailAddress As String
    Private m_Role As Role
    Private m_ReportTo As TeamMember

    Public Sub New()
        Id = -1
    End Sub

    Public Overridable Property Id() As Integer Implements IIdentifier.Id
        Get
            Return m_Id
        End Get
        Set(ByVal value As Integer)
            m_Id = value
        End Set
    End Property

    Public Overridable Property EmployeeId() As String
        Get
            Return m_EmployeeId
        End Get
        Set(ByVal value As String)
            m_EmployeeId = value
        End Set
    End Property

    Public Overridable Property EmployeeName() As String
        Get
            Return m_EmployeeName
        End Get
        Set(ByVal value As String)
            m_EmployeeName = value
        End Set
    End Property

    Public Overridable Property Department() As String
        Get
            Return m_Department
        End Get
        Set(ByVal value As String)
            m_Department = value
        End Set
    End Property

    Public Overridable Property SubDepartment() As String
        Get
            Return m_SubDepartment
        End Get
        Set(ByVal value As String)
            m_SubDepartment = value
        End Set
    End Property

    Public Overridable Property EmailAddress() As String
        Get
            Return m_EmailAddress
        End Get
        Set(ByVal value As String)
            m_EmailAddress = value
        End Set
    End Property

    Public Overridable Property Role() As Role
        Get
            Return m_Role
        End Get
        Set(ByVal value As Role)
            m_Role = value
        End Set
    End Property

    Public Overridable Property ReportTo() As TeamMember
        Get
            Return m_ReportTo
        End Get
        Set(ByVal value As TeamMember)
            m_ReportTo = value
        End Set
    End Property

    Public Function DeepClone() As TeamMember Implements IDeepClone(Of TeamMember).DeepClone
        Dim clonedTeamMember As TeamMember = New TeamMember()
        clonedTeamMember.Id = Id
        clonedTeamMember.EmployeeId = EmployeeId
        clonedTeamMember.EmployeeName = EmployeeName
        clonedTeamMember.Department = Department
        clonedTeamMember.SubDepartment = SubDepartment
        clonedTeamMember.EmailAddress = EmailAddress
        If (Role IsNot Nothing) Then
            clonedTeamMember.Role = Role.DeepClone()
        End If
        If (ReportTo IsNot Nothing) Then
            clonedTeamMember.ReportTo = ReportTo.DeepClone()
        End If
        Return clonedTeamMember
    End Function
End Class
