﻿Option Strict On
Option Explicit On
Option Infer Off
Imports Securex.FIT.Fitclient.Business.DataHolders

Public Class WorkPackageSelection
    Inherits GenericSelection(Of WorkPackage)

    Public Sub New()
        MyBase.New()
    End Sub

    ''' <summary>
    ''' Update name
    ''' </summary>
    ''' <param name="name">Name of workpacke</param>
    ''' <remarks></remarks>
    Public Sub UpdateName(ByVal name As String)
        MyBase.Selection.Name = name
    End Sub

    ''' <summary>
    ''' Update the estimated time
    ''' </summary>
    ''' <param name="estimatedTime">Expected time needed to complete the workpackage</param>
    ''' <remarks></remarks>
    Public Sub UpdateEstimatedTime(ByVal estimatedTime As String)
        MyBase.Selection.EstimatedTime = estimatedTime
    End Sub

    ''' <summary>
    ''' Update responsible
    ''' </summary>
    ''' <param name="responsibleId">Employee id</param>
    ''' <param name="responsibleName">Employee name</param>
    ''' <remarks></remarks>
    Public Sub UpdateResponsible(ByVal responsibleId As String, ByVal responsibleName As String)
        MyBase.Selection.ResponsibleId = responsibleId
        MyBase.Selection.ResponsibleName = responsibleName
    End Sub

    ''' <summary>
    ''' Update due date
    ''' </summary>
    ''' <param name="dueDate">Expected end date</param>
    ''' <remarks></remarks>
    Public Sub UpdateDueDate(ByVal dueDate As DateTime)
        MyBase.Selection.DueDate = dueDate
    End Sub

    ''' <summary>
    ''' Get selection
    ''' </summary>
    ''' <returns>Returns the workpackage object</returns>
    ''' <remarks></remarks>
    Public Overrides Function GetSelection() As DataHolders.WorkPackage
        Return MyBase.Selection
    End Function
End Class
