﻿Option Strict On
Option Explicit On
Option Infer Off
Imports Securex.FIT.Fitclient.Business.DataHolders

Public Class TaskMilestone
    Private m_Selection As MilestoneSelection
    Private m_WorkPackageName As String

    Public Sub New(ByVal workPackageName As String)
        Selection = New MilestoneSelection()
        SetWorkPackageName = workPackageName
    End Sub

    ''' <summary>
    ''' Add this milestone to the selection
    ''' </summary>
    ''' <param name="milestone">Milestone object</param>
    ''' <remarks></remarks>
    Public Sub Add(ByVal milestone As Milestone)
        Selection.Add(milestone)
    End Sub

    ''' <summary>
    ''' Update the milestone name
    ''' </summary>
    ''' <param name="name">Name of milestone</param>
    ''' <remarks></remarks>
    Public Sub UpdateName(ByVal name As String)
        Selection.UpdateName(name)
    End Sub

    ''' <summary>
    ''' Update the milestone description
    ''' </summary>
    ''' <param name="description">Milestone description</param>
    ''' <remarks></remarks>
    Public Sub UpdateDescription(ByVal description As String)
        Selection.UpdateDescription(description)
    End Sub

    ''' <summary>
    ''' Update the milestone begin date
    ''' </summary>
    ''' <param name="beginDate">Begin date</param>
    ''' <remarks></remarks>
    Public Sub UpdateBeginDate(ByVal beginDate As DateTime)
        Selection.UpdateBeginDate(beginDate)
    End Sub

    ''' <summary>
    ''' Update the milestone end date
    ''' </summary>
    ''' <param name="endDate">End date</param>
    ''' <remarks></remarks>
    Public Sub UpdateEndDate(ByVal endDate As DateTime)
        Selection.UpdateEndDate(endDate)
    End Sub

    ''' <summary>
    ''' Clear the selection
    ''' </summary>
    ''' <remarks></remarks>
    Public Sub ClearSelection()
        Selection.Clear()
    End Sub

    ''' <summary>
    ''' Get the milestone in the selection
    ''' </summary>
    ''' <returns>Returns the milestone object in the selection</returns>
    ''' <remarks></remarks>
    Public Function GetSelection() As Milestone
        Return Selection.GetSelection()
    End Function

    ''' <summary>
    ''' Get the workpackage name
    ''' </summary>
    ''' <returns>Returns the workpackage name</returns>
    ''' <remarks></remarks>
    Public ReadOnly Property WorkPackageName() As String
        Get
            Return m_WorkPackageName
        End Get
    End Property

    Private Property Selection() As MilestoneSelection
        Get
            Return m_Selection
        End Get
        Set(ByVal value As MilestoneSelection)
            m_Selection = value
        End Set
    End Property

    Private WriteOnly Property SetWorkPackageName() As String
        Set(ByVal value As String)
            m_WorkPackageName = value
        End Set
    End Property

End Class
