﻿Option Strict On
Option Explicit On
Option Infer Off
Imports Securex.FIT.Fitclient.Business.DataHolders

Public Class TaskProjectProposalName
    Private Shared m_TaskProjectProposalName As TaskProjectProposalName = New TaskProjectProposalName()

    Private Sub New()
    End Sub

    Public Shared ReadOnly Property Instance() As TaskProjectProposalName
        Get
            Return m_TaskProjectProposalName
        End Get
    End Property

    ''' <summary>
    ''' Get all project proposal names
    ''' </summary>
    ''' <returns>Returns an IList of project proposal names</returns>
    ''' <remarks></remarks>
    Public Function GetAllProjectProposalNames() As IList(Of ProjectProposalName)
        Dim session As ISessionDao = Nothing
        Try
            session = Facade.Instance.RepositoryFactory.CreateSession()
            GetAllProjectProposalNames = Facade.Instance.RepositoryFactory.ProjectProPosalName.GetAllProjectProposalNames(session)
            session.CancelAndClose()
        Catch ex As RepositoryException
            If (session IsNot Nothing) Then
                session.CancelAndClose()
            End If
            Throw New Exception(ex.Message, ex.InnerException)
        End Try
    End Function
End Class
