﻿Option Strict On
Option Explicit On
Option Infer Off
Imports Securex.FIT.Fitclient.Business
Imports Securex.FIT.Fitclient.Business.DataHolders

Public Class PresenterFormCategoryEditor
    Private m_View As IViewFormCategoryEditor

    Public Sub New(ByVal view As IViewFormCategoryEditor)
        MyClass.View = view
    End Sub

    Public Sub Save()
        Try
            TaskCategory.Instance.Save()
            TaskCategory.Instance.ClearSelection()
            CloseView()
        Catch ex As Exception
            Throw New Exception(ex.Message)
        End Try
    End Sub

    Public Sub Cancel()
        CloseView()
    End Sub

    Public Sub SetSelection(ByVal category As Category)
        TaskCategory.Instance.Add(category)
    End Sub

    Public Sub UpdateSelelection(ByVal description As String)
        TaskCategory.Instance.UpdateCategory(description)
    End Sub

    Public Sub SendChangedViewEvent()
        DispatcherChangedViewEvent.SendChangedViewEvent(Me, New ChangedViewEvent(View.GetText(), Nothing))
    End Sub

    Public Sub RequestCategoryByDescription(ByVal description As String)
        Try
            Dim category As Category = TaskCategory.Instance.GetCategoryByDescription(description)
            If (category Is Nothing) Then
                category = New Category()
            End If
            TaskCategory.Instance.Add(category)
            View.UpdateView(category)
        Catch ex As Exception
            Throw New Exception(ex.Message)
        End Try
    End Sub

    Private Sub CloseView()
        DispatcherClosedViewEvent.SendClosedViewEvent(Me, Nothing)
    End Sub

    Private Property View() As IViewFormCategoryEditor
        Get
            Return m_View
        End Get
        Set(ByVal value As IViewFormCategoryEditor)
            m_View = value
        End Set
    End Property
End Class
