﻿Option Strict On
Option Explicit On
Option Infer Off
Imports Securex.FIT.Fitclient.Business
Imports Securex.FIT.Fitclient.Business.DataHolders

Public Class PresenterFormMilestoneEditor
    Private m_View As IViewFormMilestoneEditor
    Private m_Task As TaskMilestone

    Public Sub New(ByVal view As IViewFormMilestoneEditor, ByVal workPackageName As String)
        MyClass.View = view
        Task = New TaskMilestone(workPackageName)
        SendSubEditorOpenedEvent(False)
    End Sub

    Public Sub Apply()
        SendFormClosing()
    End Sub

    Public Sub Cancel()
        CloseView()
    End Sub

    Public Sub SetSelection(ByVal milestone As Milestone)
        Task.Add(milestone)
    End Sub

    Public Sub UpdateName(ByVal name As String)
        Task.UpdateName(name)
    End Sub

    Public Sub UpdateDescription(ByVal description As String)
        Task.UpdateDescription(description)
    End Sub

    Public Sub UpdateBeginDate(ByVal startDate As DateTime)
        Task.UpdateBeginDate(startDate)
    End Sub

    Public Sub UpdateEndDate(ByVal endDate As DateTime)
        Task.UpdateEndDate(endDate)
    End Sub

    Public Sub SendChangedViewEvent()
        DispatcherChangedViewEvent.SendChangedViewEvent(Me, New ChangedViewEvent(View.GetText(), Nothing))
    End Sub

    Public Sub UpdateMilestone()
        TaskProjectProposalRevision.Instance.AddOrUpdateMilestone(Task.WorkPackageName, Task.GetSelection())
        CloseView()
    End Sub

    Private Sub CloseView()
        Task.ClearSelection()
        SendFormClosing()
    End Sub

    Private Sub SendFormClosing()
        SendClosedViewEvent()
        SendSubEditorOpenedEvent(True)
    End Sub

    Private Sub SendClosedViewEvent()
        DispatcherClosedViewEvent.SendClosedViewEvent(Me, Nothing)
    End Sub

    Private Sub SendSubEditorOpenedEvent(ByVal enabled As Boolean)
        DispatcherSubEditorOpenedEvent.SendSubEditorOpenedEvent(Me, New SubEditorOpenedEvent(enabled))
    End Sub

    Private Property View() As IViewFormMilestoneEditor
        Get
            Return m_View
        End Get
        Set(ByVal value As IViewFormMilestoneEditor)
            m_View = value
        End Set
    End Property

    Private Property Task() As TaskMilestone
        Get
            Return m_Task
        End Get
        Set(ByVal value As TaskMilestone)
            m_Task = value
        End Set
    End Property
End Class
