﻿Option Strict On
Option Explicit On
Option Infer Off
Imports Securex.FIT.Fitclient.Business
Imports Securex.FIT.Fitclient.Business.DataHolders
Imports System.Windows.Forms
Imports CustomControls

Public Class PresenterFormPartDescriptionOverview
    Private m_View As IViewFormPartDescriptionOverview

    Public Sub New(ByVal view As IViewFormPartDescriptionOverview)
        MyClass.View = view

        'add listener for closed view
        AddHandler DispatcherClosedViewEvent.ClosedView, AddressOf ClosedView
    End Sub

    Public Sub RequestAllPartDescriptions()
        Try
            View.ClearExtendedListViewPartDescription()
            Dim formDescriptions As IList(Of FormDescription) = TaskFormDescription.Instance.GetAllFormDescriptions()
            If (formDescriptions IsNot Nothing) Then
                Dim enumerator As IEnumerator(Of FormDescription) = formDescriptions.GetEnumerator()
                While (enumerator.MoveNext())
                    Dim listViewItem As FourStateListViewItem = New FourStateListViewItem()
                    listViewItem.Text = enumerator.Current.FormName
                    listViewItem.Tag = enumerator.Current.Id
                    listViewItem.SubItems.Add(New ListViewItem.ListViewSubItem(listViewItem, enumerator.Current.Description))
                    View.AddToExtendedListViewPartDescription(listViewItem)
                End While
            End If
            View.UpdateView()
        Catch ex As Exception
            Throw New Exception(ex.Message, ex.InnerException)
        End Try
    End Sub

    Public Sub Remove(ByVal id As Integer)
        Try
            TaskFormDescription.Instance.Remove(id)
        Catch ex As Exception
            Throw New Exception(ex.Message, ex.InnerException)
        End Try
    End Sub

    Public Sub Close()
        DispatcherClosedViewEvent.SendClosedViewEvent(Me, New ClosedViewEvent())
    End Sub

    Public Sub ShowPartDescriptionEditor(ByVal id As Integer)
        Dim formDescription As FormDescription = TaskFormDescription.Instance.GetDescriptionById(id)
        DispatcherOpenPartDescriptionEditorViewEvent.SendOpenPartDescriptionEditorViewEvent(Me, New OpenEditorViewEvent(Of FormDescription)(PresenterFormPartDescription.PART_DESCRIPTION_EDITOR, formDescription))
    End Sub

    Public Sub SendChangedViewEvent()
        DispatcherChangedViewEvent.SendChangedViewEvent(Me, New ChangedViewEvent(View.GetText(), Nothing))
    End Sub

    Private Sub ClosedView(ByVal sender As Object, ByVal e As ClosedViewEvent)
        If (sender.GetType() Is GetType(PresenterFormPartDescriptionEditor)) Then
            View.UpdateView()
        End If
    End Sub

    Private Property View() As IViewFormPartDescriptionOverview
        Get
            Return m_View
        End Get
        Set(ByVal value As IViewFormPartDescriptionOverview)
            m_View = value
        End Set
    End Property
End Class
