﻿Option Strict On
Option Explicit On
Option Infer Off
Imports Securex.FIT.Fitclient.Business

Public Class PresenterFormProjectScreen2
    Private m_View As IViewProjectScreen2

    Public Sub New(ByVal view As IViewProjectScreen2)
        MyClass.View = view

        'add listener for RefreshViewOnSave event
        AddHandler DispatcherRefreshViewOnSaveEvent.RefreshViewOnSave, AddressOf RefreshViewOnSave
    End Sub

    Public Sub SendChangedViewEvent()
        DispatcherChangedViewEvent.SendChangedViewEvent(Me, New ChangedViewEvent(View.GetText(), TaskFormDescription.Instance.GetDescriptionByFormName(View.GetName()).Description))
    End Sub

    Public Sub RequestSelection()
        Try
            View.UpdateView(TaskProjectProposalRevision.Instance.GetSelection())
        Catch ex As Exception
            ThrowException(ex)
        End Try
    End Sub

    Public Sub UpdateWhy(ByVal text As String)
        Try
            TaskProjectProposalRevision.Instance.UpdateWhy(text)
        Catch ex As Exception
            ThrowException(ex)
        End Try
    End Sub

    Public Sub UpdateInclude(ByVal text As String)
        Try
            TaskProjectProposalRevision.Instance.UpdateInclude(text)
        Catch ex As Exception
            ThrowException(ex)
        End Try
    End Sub

    Public Sub UpdateExclude(ByVal text As String)
        Try
            TaskProjectProposalRevision.Instance.UpdateExclude(text)
        Catch ex As Exception
            ThrowException(ex)
        End Try
    End Sub

    Public Sub UpdateAsIs(ByVal text As String)
        Try
            TaskProjectProposalRevision.Instance.UpdateAsIs(text)
        Catch ex As Exception
            ThrowException(ex)
        End Try
    End Sub

    Public Sub UpdateToBe(ByVal text As String)
        Try
            TaskProjectProposalRevision.Instance.UpdateToBe(text)
        Catch ex As Exception
            ThrowException(ex)
        End Try
    End Sub

    Public ReadOnly Property IsEditable() As Boolean
        Get
            Return TaskProjectProposalRevision.Instance.IsEditable()
        End Get
    End Property

    Private Sub RefreshViewOnSave(ByVal sender As Object, ByVal e As RefreshViewOnSaveEvent)
        View.UpdateView(TaskProjectProposalRevision.Instance.GetSelection())
    End Sub

    Private Sub ThrowException(ByVal exception As Exception)
        Throw New Exception(exception.Message)
    End Sub

    Private Property View() As IViewProjectScreen2
        Get
            Return m_View
        End Get
        Set(ByVal value As IViewProjectScreen2)
            m_View = value
        End Set
    End Property
End Class
