﻿Option Strict On
Option Explicit On
Option Infer Off
Imports Securex.FIT.Fitclient.Business

Public Class PresenterFormProjectScreen3
    Private m_View As IViewProjectScreen3

    Public Sub New(ByVal view As IViewProjectScreen3)
        MyClass.View = view

        'add listener for RefreshViewOnSave event
        AddHandler DispatcherRefreshViewOnSaveEvent.RefreshViewOnSave, AddressOf RefreshViewOnSave
    End Sub

    Public Sub SendChangedViewEvent()
        DispatcherChangedViewEvent.SendChangedViewEvent(Me, New ChangedViewEvent(View.GetText(), TaskFormDescription.Instance.GetDescriptionByFormName(View.GetName()).Description))
    End Sub

    Public Sub RequestSelection()
        Try
            View.UpdateView(TaskProjectProposalRevision.Instance.GetSelection())
        Catch ex As Exception
            ThrowException(ex)
        End Try
    End Sub

    Public Sub UpdateObjectifs(ByVal text As String)
        Try
            TaskProjectProposalRevision.Instance.UpdateObjectifs(text)
        Catch ex As Exception
            ThrowException(ex)
        End Try
    End Sub

    Public Sub UpdateCost(ByVal text As String)
        Try
            TaskProjectProposalRevision.Instance.UpdateCost(text)
        Catch ex As Exception
            ThrowException(ex)
        End Try
    End Sub

    Public Sub UpdateBenefits(ByVal text As String)
        Try
            TaskProjectProposalRevision.Instance.UpdateBenefits(text)
        Catch ex As Exception
            ThrowException(ex)
        End Try
    End Sub

    Public Sub UpdateAlignation(ByVal text As String)
        Try
            TaskProjectProposalRevision.Instance.UpdateAlignation(text)
        Catch ex As Exception
            ThrowException(ex)
        End Try
    End Sub

    Public ReadOnly Property IsEditable() As Boolean
        Get
            Return TaskProjectProposalRevision.Instance.IsEditable()
        End Get
    End Property

    Private Sub RefreshViewOnSave(ByVal sender As Object, ByVal e As RefreshViewOnSaveEvent)
        View.UpdateView(TaskProjectProposalRevision.Instance.GetSelection())
    End Sub

    Private Sub ThrowException(ByVal exception As Exception)
        Throw New Exception(exception.Message)
    End Sub

    Private Property View() As IViewProjectScreen3
        Get
            Return m_View
        End Get
        Set(ByVal value As IViewProjectScreen3)
            m_View = value
        End Set
    End Property
End Class
