﻿Option Strict On
Option Explicit On
Option Infer Off
Imports Securex.FIT.Fitclient.Business

Public Class PresenterFormProjectScreen5
    Private m_View As IViewProjectScreen5

    Public Sub New(ByVal view As IViewProjectScreen5)
        MyClass.View = view

        'add listener for RefreshViewOnSave event
        AddHandler DispatcherRefreshViewOnSaveEvent.RefreshViewOnSave, AddressOf RefreshViewOnSave
    End Sub

    Public Sub SendChangedViewEvent()
        Try
            DispatcherChangedViewEvent.SendChangedViewEvent(Me, New ChangedViewEvent(View.GetText(), TaskFormDescription.Instance.GetDescriptionByFormName(View.GetName()).Description))
        Catch ex As Exception
            ThrowException(ex)
        End Try
    End Sub

    Public Sub RequestSelection()
        Try
            View.UpdateView(TaskProjectProposalRevision.Instance.GetSelection())
        Catch ex As Exception
            ThrowException(ex)
        End Try
    End Sub

    Public Sub UpdatePreconditions(ByVal preconditions As String)
        Try
            TaskProjectProposalRevision.Instance.UpdatePreconditions(preconditions)
        Catch ex As Exception
            ThrowException(ex)
        End Try
    End Sub

    Public Sub UpdateConstraints(ByVal constraints As String)
        Try
            TaskProjectProposalRevision.Instance.UpdateConstraints(constraints)
        Catch ex As Exception
            ThrowException(ex)
        End Try
    End Sub

    Public Sub UpdateDependencies(ByVal dependencies As String)
        Try
            TaskProjectProposalRevision.Instance.UpdateDependencies(dependencies)
        Catch ex As Exception
            ThrowException(ex)
        End Try
    End Sub

    Public Sub UpdateRisk(ByVal risk As String)
        Try
            TaskProjectProposalRevision.Instance.UpdateRisk(risk)
        Catch ex As Exception
            ThrowException(ex)
        End Try
    End Sub

    Public Sub UpdateSupport(ByVal support As String)
        Try
            TaskProjectProposalRevision.Instance.UpdateSupport(support)
        Catch ex As Exception
            ThrowException(ex)
        End Try
    End Sub

    Public ReadOnly Property IsEditable() As Boolean
        Get
            Return TaskProjectProposalRevision.Instance.IsEditable()
        End Get
    End Property

    Private Sub RefreshViewOnSave(ByVal sender As Object, ByVal e As RefreshViewOnSaveEvent)
        View.UpdateView(TaskProjectProposalRevision.Instance.GetSelection())
    End Sub

    Private Sub ThrowException(ByVal exception As Exception)
        Throw New Exception(exception.Message)
    End Sub

    Private Property View() As IViewProjectScreen5
        Get
            Return m_View
        End Get
        Set(ByVal value As IViewProjectScreen5)
            m_View = value
        End Set
    End Property
End Class
