﻿Option Strict On
Option Explicit On
Option Infer Off
Imports Securex.FIT.Fitclient.Business
Imports Securex.FIT.Fitclient.Business.DataHolders
Imports NHibernate
Imports NHibernate.Criterion

Public Class SqlEmployee
    Implements IEmployeeDao
    Private Const EMPLOYEEID As String = "EmployeeId"
    Private Const ACTIVE As String = "Active"
    Private m_GenericNhbDao As GenericNhbDao(Of Employee)

    Public Sub New()
        m_GenericNhbDao = New GenericNhbDao(Of Employee)()
    End Sub

#Region "IEmployee"
    ''' <summary>
    ''' Get all employees
    ''' </summary>
    ''' <param name="session">Object containing the session to the database</param>
    ''' <returns>Returns an IList of employees</returns>
    ''' <remarks></remarks>
    Public Function GetAllEmployees(ByVal session As Business.ISessionDao) As System.Collections.Generic.IList(Of Business.DataHolders.Employee) Implements Business.IEmployeeDao.GetAllEmployees
        Try
            Dim criterions As ICriterion() = {Restrictions.IsNull(ACTIVE)}
            Return m_GenericNhbDao.GetForCriteria(DirectCast(session, SqlSession).Session, criterions, Nothing)
        Catch ex As NHibernateException
            Throw New RepositoryException(ex.Message, ex.InnerException)
        End Try
    End Function

    ''' <summary>
    ''' Get employee for employee id
    ''' </summary>
    ''' <param name="session">Object containing the session to the database</param>
    ''' <param name="employeeID">Employee id</param>
    ''' <returns>Returns an IList of employees</returns>
    ''' <remarks></remarks>
    Public Function GetEmployeeForEmployeeID(ByVal session As Business.ISessionDao, ByVal employeeID As String) As System.Collections.Generic.IList(Of Business.DataHolders.Employee) Implements Business.IEmployeeDao.GetEmployeeForEmployeeID
        Try
            Dim orders As Order() = {New Order(SqlEmployee.EMPLOYEEID, True)}
            Dim criterions As ICriterion() = {New LikeExpression(SqlEmployee.EMPLOYEEID, employeeID.ToString(), MatchMode.Exact)}
            Return m_GenericNhbDao.GetForCriteria(DirectCast(session, SqlSession).Session, criterions, orders)
        Catch ex As NHibernateException
            Throw New RepositoryException(ex.Message, ex.InnerException)
        End Try
    End Function
#End Region
End Class
