﻿Option Strict On
Option Explicit On
Option Infer Off
Imports Securex.FIT.Fitclient.Business

Public Class SqlFactory
    Implements IRepositoryFactory
    Private Shared m_SqlFactory As SqlFactory = New SqlFactory()
    Private m_SqlConfiguration As SqlConfiguration
    Private m_SqlFormDescription As SqlFormDescription
    Private m_SqlCategory As SqlCategory
    Private m_SqlSubCategory As SqlSubCategory
    Private m_SqlProjectProposalRevision As SqlProjectProposalRevision
    Private m_SqlProjectProposalName As SqlProjectProposalName
    Private m_SqlRevisionStatus As SqlRevisionStatus
    Private m_SqlPrivileges As SqlPrivileges
    Private m_SqlRole As SqlRole

    Private Sub New()
        m_SqlConfiguration = New SqlConfiguration(RunningEnvironment.Instance.GetEnvironment)
        m_SqlFormDescription = New SqlFormDescription()
        m_SqlCategory = New SqlCategory()
        m_SqlSubCategory = New SqlSubCategory()
        m_SqlProjectProposalRevision = New SqlProjectProposalRevision()
        m_SqlProjectProposalName = New SqlProjectProposalName()
        m_SqlRevisionStatus = New SqlRevisionStatus()
        m_SqlPrivileges = New SqlPrivileges()
        m_SqlRole = New SqlRole()
    End Sub

    Public Shared ReadOnly Property Instance() As SqlFactory
        Get
            Return m_SqlFactory
        End Get
    End Property

#Region "IRepositoryFactory"
    Public Function CreateSession() As Business.ISessionDao Implements Business.IRepositoryFactory.CreateSession
        Return New SqlSession(m_SqlConfiguration.SessionFactory)
    End Function

    Public ReadOnly Property FormDescription() As Business.IFormDescriptionDao Implements Business.IRepositoryFactory.FormDescription
        Get
            Return m_SqlFormDescription
        End Get
    End Property

    Public ReadOnly Property Category() As Business.ICategoryDao Implements Business.IRepositoryFactory.Category
        Get
            Return m_SqlCategory
        End Get
    End Property

    Public ReadOnly Property SubCategory() As Business.ISubCategoryDao Implements Business.IRepositoryFactory.SubCategory
        Get
            Return m_SqlSubCategory
        End Get
    End Property

    Public ReadOnly Property ProjectProposalRevision() As Business.IProjectProposalRevisionDao Implements Business.IRepositoryFactory.ProjectProposalRevision
        Get
            Return m_SqlProjectProposalRevision
        End Get
    End Property

    Public ReadOnly Property ProjectProPosalName() As Business.IProjectProposalNameDao Implements Business.IRepositoryFactory.ProjectProPosalName
        Get
            Return m_SqlProjectProposalName
        End Get
    End Property

    Public ReadOnly Property Employee() As Business.IEmployeeDao Implements Business.IRepositoryFactory.Employee
        Get
            Return New SqlEmployee()
        End Get
    End Property

    Public ReadOnly Property RevisionStatus() As Business.IRevisionStatusDao Implements Business.IRepositoryFactory.RevisionStatus
        Get
            Return m_SqlRevisionStatus
        End Get
    End Property

    Public ReadOnly Property Privileges() As Business.IPrivileges Implements Business.IRepositoryFactory.Privileges
        Get
            Return m_SqlPrivileges
        End Get
    End Property

    Public ReadOnly Property Role() As Business.IRoleDao Implements Business.IRepositoryFactory.Role
        Get
            Return m_SqlRole
        End Get
    End Property
#End Region

End Class
