﻿Option Strict On
Option Explicit On
Option Infer Off

<Serializable()> _
Public Class ProjectProposalRevision
    Implements IDeepClone(Of ProjectProposalRevision)
    Private m_Id As Integer
    Private m_ProjectDescription As String
    Private m_Creator As Creator
    Private m_Auditor As Auditor
    Private m_SponsorId As String
    Private m_SponsorName As String
    Private m_PusherId As String
    Private m_PusherName As String
    Private m_CoordinatorId As String
    Private m_CoordinatorName As String
    Private m_Budget As String
    Private m_Why As String
    Private m_Include As String
    Private m_Exclude As String
    Private m_AsIs As String
    Private m_ToBe As String
    Private m_Objectifs As String
    Private m_Cost As String
    Private m_Benefits As String
    Private m_Alignation As String
    Private m_Preconditions As String
    Private m_Constraints As String
    Private m_Dependencies As String
    Private m_Risk As String
    Private m_Support As String
    Private m_IsCurrentRevision As Boolean
    Private m_PreviousRevisionId As Nullable(Of Integer)
    Private m_ProjectProposalName As ProjectProposalName
    Private m_SubCategory As SubCategory
    Private m_WorkPackages As IList(Of WorkPackage)
    Private m_TeamMembers As IList(Of TeamMember)
    Private m_RevisionInformation As RevisionStatusLine

    Public Sub New()
        Id = -1
        IsCurrentRevision = True
        Project = New ProjectProposalName()
        Creator = New Creator()
        Auditor = New Auditor()
        RevisionInformation = New RevisionStatusLine()
        WorkPackages = New List(Of WorkPackage)()
        TeamMembers = New List(Of TeamMember)()
    End Sub

    Public Overridable Property Id() As Integer
        Get
            Return m_Id
        End Get
        Set(ByVal value As Integer)
            m_Id = value
        End Set
    End Property

    Public Overridable Property ProjectDescription() As String
        Get
            Return m_ProjectDescription
        End Get
        Set(ByVal value As String)
            m_ProjectDescription = value
        End Set
    End Property

    Public Overridable Property SponsorId() As String
        Get
            Return m_SponsorId
        End Get
        Set(ByVal value As String)
            m_SponsorId = value
        End Set
    End Property

    Public Overridable Property SponsorName() As String
        Get
            Return m_SponsorName
        End Get
        Set(ByVal value As String)
            m_SponsorName = value
        End Set
    End Property

    Public Overridable Property PusherId() As String
        Get
            Return m_PusherId
        End Get
        Set(ByVal value As String)
            m_PusherId = value
        End Set
    End Property

    Public Overridable Property PusherName() As String
        Get
            Return m_PusherName
        End Get
        Set(ByVal value As String)
            m_PusherName = value
        End Set
    End Property

    Public Overridable Property CoordinatorId() As String
        Get
            Return m_CoordinatorId
        End Get
        Set(ByVal value As String)
            m_CoordinatorId = value
        End Set
    End Property

    Public Overridable Property CoordinatorName() As String
        Get
            Return m_CoordinatorName
        End Get
        Set(ByVal value As String)
            m_CoordinatorName = value
        End Set
    End Property

    Public Overridable Property Budget() As String
        Get
            Return m_Budget
        End Get
        Set(ByVal value As String)
            m_Budget = value
        End Set
    End Property

    Public Overridable Property Why() As String
        Get
            Return m_Why
        End Get
        Set(ByVal value As String)
            m_Why = value
        End Set
    End Property

    Public Overridable Property Include() As String
        Get
            Return m_Include
        End Get
        Set(ByVal value As String)
            m_Include = value
        End Set
    End Property

    Public Overridable Property Exclude() As String
        Get
            Return m_Exclude
        End Get
        Set(ByVal value As String)
            m_Exclude = value
        End Set
    End Property

    Public Overridable Property AsIs() As String
        Get
            Return m_AsIs
        End Get
        Set(ByVal value As String)
            m_AsIs = value
        End Set
    End Property

    Public Overridable Property ToBe() As String
        Get
            Return m_ToBe
        End Get
        Set(ByVal value As String)
            m_ToBe = value
        End Set
    End Property

    Public Overridable Property Objectifs() As String
        Get
            Return m_Objectifs
        End Get
        Set(ByVal value As String)
            m_Objectifs = value
        End Set
    End Property

    Public Overridable Property Cost() As String
        Get
            Return m_Cost
        End Get
        Set(ByVal value As String)
            m_Cost = value
        End Set
    End Property

    Public Overridable Property Benefits() As String
        Get
            Return m_Benefits
        End Get
        Set(ByVal value As String)
            m_Benefits = value
        End Set
    End Property

    Public Overridable Property Alignation() As String
        Get
            Return m_Alignation
        End Get
        Set(ByVal value As String)
            m_Alignation = value
        End Set
    End Property

    Public Overridable Property Preconditions() As String
        Get
            Return m_Preconditions
        End Get
        Set(ByVal value As String)
            m_Preconditions = value
        End Set
    End Property

    Public Overridable Property Constraints() As String
        Get
            Return m_Constraints
        End Get
        Set(ByVal value As String)
            m_Constraints = value
        End Set
    End Property

    Public Overridable Property Dependencies() As String
        Get
            Return m_Dependencies
        End Get
        Set(ByVal value As String)
            m_Dependencies = value
        End Set
    End Property

    Public Overridable Property Risk() As String
        Get
            Return m_Risk
        End Get
        Set(ByVal value As String)
            m_Risk = value
        End Set
    End Property

    Public Overridable Property Support() As String
        Get
            Return m_Support
        End Get
        Set(ByVal value As String)
            m_Support = value
        End Set
    End Property

    Public Overridable Property IsCurrentRevision() As Boolean
        Get
            Return m_IsCurrentRevision
        End Get
        Set(ByVal value As Boolean)
            m_IsCurrentRevision = value
        End Set
    End Property

    Public Overridable Property PreviousRevisionId() As Nullable(Of Integer)
        Get
            Return m_PreviousRevisionId
        End Get
        Set(ByVal value As Nullable(Of Integer))
            m_PreviousRevisionId = value
        End Set
    End Property

    Public Overridable Property Project() As ProjectProposalName
        Get
            Return m_ProjectProposalName
        End Get
        Set(ByVal value As ProjectProposalName)
            m_ProjectProposalName = value
        End Set
    End Property

    Public Overridable Property Creator() As Creator
        Get
            Return m_Creator
        End Get
        Set(ByVal value As Creator)
            m_Creator = value
        End Set
    End Property

    Public Overridable Property Auditor() As Auditor
        Get
            Return m_Auditor
        End Get
        Set(ByVal value As Auditor)
            m_Auditor = value
        End Set
    End Property

    Public Overridable Property SubCategory() As SubCategory
        Get
            Return m_SubCategory
        End Get
        Set(ByVal value As SubCategory)
            m_SubCategory = value
        End Set
    End Property

    Public Overloads Property RevisionInformation() As RevisionStatusLine
        Get
            Return m_RevisionInformation
        End Get
        Set(ByVal value As RevisionStatusLine)
            m_RevisionInformation = value
        End Set
    End Property

    Public Overridable Property WorkPackages() As IList(Of WorkPackage)
        Get
            Return New List(Of WorkPackage)(m_WorkPackages)
        End Get
        Set(ByVal value As IList(Of WorkPackage))
            m_WorkPackages = New List(Of WorkPackage)(value)
        End Set
    End Property

    Public Overridable Property TeamMembers() As IList(Of TeamMember)
        Get
            Return New List(Of TeamMember)(m_TeamMembers)
        End Get
        Set(ByVal value As IList(Of TeamMember))
            m_TeamMembers = New List(Of TeamMember)(value)
        End Set
    End Property

#Region "IDeepClone"
    Public Overridable Function DeepClone() As ProjectProposalRevision Implements IDeepClone(Of ProjectProposalRevision).DeepClone
        Dim clonedProjectProposal As ProjectProposalRevision = New ProjectProposalRevision()
        clonedProjectProposal.Id = Id
        clonedProjectProposal.ProjectDescription = ProjectDescription
        clonedProjectProposal.SponsorId = SponsorId
        clonedProjectProposal.SponsorName = SponsorName
        clonedProjectProposal.PusherId = PusherId
        clonedProjectProposal.PusherName = PusherName
        clonedProjectProposal.CoordinatorId = CoordinatorId
        clonedProjectProposal.CoordinatorName = CoordinatorName
        clonedProjectProposal.Budget = Budget
        clonedProjectProposal.Why = Why
        clonedProjectProposal.Include = Include
        clonedProjectProposal.Exclude = Exclude
        clonedProjectProposal.AsIs = AsIs
        clonedProjectProposal.ToBe = ToBe
        clonedProjectProposal.Objectifs = Objectifs
        clonedProjectProposal.Cost = Cost
        clonedProjectProposal.Benefits = Benefits
        clonedProjectProposal.Alignation = Alignation
        clonedProjectProposal.Preconditions = Preconditions
        clonedProjectProposal.Constraints = Constraints
        clonedProjectProposal.Dependencies = Dependencies
        clonedProjectProposal.Risk = Risk
        clonedProjectProposal.Support = Support
        clonedProjectProposal.IsCurrentRevision = IsCurrentRevision
        clonedProjectProposal.Project = Project.DeepClone()
        clonedProjectProposal.Creator = Creator.DeepClone()
        clonedProjectProposal.Auditor = Auditor.DeepClone()
        If (PreviousRevisionId.HasValue) Then 'check if value is nothing
            clonedProjectProposal.PreviousRevisionId = PreviousRevisionId.Value
        End If
        clonedProjectProposal.RevisionInformation = RevisionInformation.DeepClone()
        'subcategories
        If (SubCategory IsNot Nothing) Then
            clonedProjectProposal.SubCategory = SubCategory.DeepClone()
        End If
        'workpackages
        clonedProjectProposal.WorkPackages = New List(Of WorkPackage)(WorkPackages)
        'teammembers
        clonedProjectProposal.TeamMembers = New List(Of TeamMember)(TeamMembers)
        Return clonedProjectProposal
    End Function
#End Region

End Class
