﻿Option Strict On
Option Explicit On
Option Infer Off

<Serializable()> _
Public Class WorkPackage
    'Implements IIdentifier
    Implements IDeepClone(Of WorkPackage), IIdentifier
    Private m_Id As Integer
    Private m_Name As String
    Private m_EstimatedTime As String
    Private m_ResposibleId As String
    Private m_ResposibleName As String
    Private m_DueDate As DateTime
    Private m_Milestones As IList(Of Milestone)

    Public Sub New()
        Id = -1
        DueDate = Now
        SetMilestones = New List(Of Milestone)()
    End Sub

    Public Overridable Property Id() As Integer Implements IIdentifier.Id
        Get
            Return m_Id
        End Get
        Set(ByVal value As Integer)
            m_Id = value
        End Set
    End Property

    Public Overridable Property Name() As String
        Get
            Return m_Name
        End Get
        Set(ByVal value As String)
            m_Name = value
        End Set
    End Property

    Public Overridable Property EstimatedTime() As String
        Get
            Return m_EstimatedTime
        End Get
        Set(ByVal value As String)
            m_EstimatedTime = value
        End Set
    End Property

    Public Overridable Property ResponsibleId() As String
        Get
            Return m_ResposibleId
        End Get
        Set(ByVal value As String)
            m_ResposibleId = value
        End Set
    End Property

    Public Overridable Property ResponsibleName() As String
        Get
            Return m_ResposibleName
        End Get
        Set(ByVal value As String)
            m_ResposibleName = value
        End Set
    End Property

    Public Overridable Property DueDate() As DateTime
        Get
            Return m_DueDate
        End Get
        Set(ByVal value As DateTime)
            m_DueDate = value
        End Set
    End Property

    Public Overridable ReadOnly Property Milestones() As IList(Of Milestone)
        Get
            Return m_Milestones
        End Get
    End Property

    Protected Overridable WriteOnly Property SetMilestones() As IList(Of Milestone)
        Set(ByVal value As IList(Of Milestone))
            m_Milestones = value
        End Set
    End Property

    Public Overridable Function DeepClone() As WorkPackage Implements IDeepClone(Of WorkPackage).DeepClone
        Dim clonedWorkPackage As WorkPackage = New WorkPackage()
        clonedWorkPackage.Id = Id
        clonedWorkPackage.Name = Name
        clonedWorkPackage.EstimatedTime = EstimatedTime
        clonedWorkPackage.ResponsibleId = ResponsibleId
        clonedWorkPackage.ResponsibleName = ResponsibleName
        clonedWorkPackage.DueDate = New DateTime(DueDate.Ticks)
        Dim clonedMilestones As IList(Of Milestone) = New List(Of Milestone)()
        Dim milestoneEnumerator As IEnumerator(Of Milestone) = Milestones.GetEnumerator()
        While (milestoneEnumerator.MoveNext())
            clonedMilestones.Add(milestoneEnumerator.Current.DeepClone())
        End While
        clonedWorkPackage.SetMilestones = clonedMilestones
        Return clonedWorkPackage
    End Function
End Class
