﻿Option Strict On
Option Explicit On
Option Infer Off
Imports Securex.FIT.Fitclient.Business.DataHolders

Public Class MilestoneSelection
    Inherits GenericSelection(Of Milestone)

    Public Sub New()
        MyBase.New()
    End Sub

    ''' <summary>
    ''' Update name
    ''' </summary>
    ''' <param name="name">Name of milestone</param>
    ''' <remarks></remarks>
    Public Sub UpdateName(ByVal name As String)
        MyBase.Selection.Name = name
    End Sub

    ''' <summary>
    ''' Update description
    ''' </summary>
    ''' <param name="description">Milestone description</param>
    ''' <remarks></remarks>
    Public Sub UpdateDescription(ByVal description As String)
        MyBase.Selection.Description = description
    End Sub

    ''' <summary>
    ''' Update begin date
    ''' </summary>
    ''' <param name="beginDate">Milestone begin date</param>
    ''' <remarks></remarks>
    Public Sub UpdateBeginDate(ByVal beginDate As DateTime)
        MyBase.Selection.BeginDate = beginDate
    End Sub

    ''' <summary>
    ''' Update end date
    ''' </summary>
    ''' <param name="endDate">Milestone end date</param>
    ''' <remarks></remarks>
    Public Sub UpdateEndDate(ByVal endDate As DateTime)
        MyBase.Selection.EndDate = endDate
    End Sub

    ''' <summary>
    ''' Get selection
    ''' </summary>
    ''' <returns>Returns the milestone object</returns>
    ''' <remarks></remarks>
    Public Overrides Function GetSelection() As DataHolders.Milestone
        Return MyBase.Selection.DeepClone()
    End Function
End Class
