﻿Option Strict On
Option Explicit On
Option Infer Off
Imports Securex.FIT.Fitclient.Business.DataHolders

Public Class TeamMemberSelection
    Inherits GenericSelection(Of TeamMember)

    Public Sub New()
        MyBase.New()
    End Sub

    ''' <summary>
    ''' Update employee id
    ''' </summary>
    ''' <param name="id">Employee id</param>
    ''' <remarks></remarks>
    Public Sub UpdateEmployeeID(ByVal id As String)
        MyBase.Selection.EmployeeId = id
    End Sub

    ''' <summary>
    ''' Update employee name
    ''' </summary>
    ''' <param name="name">Employee name</param>
    ''' <remarks></remarks>
    Public Sub UpdateEmployeeName(ByVal name As String)
        MyBase.Selection.EmployeeName = name
    End Sub

    ''' <summary>
    ''' Update department
    ''' </summary>
    ''' <param name="department">Department</param>
    ''' <remarks></remarks>
    Public Sub UpdateDepartment(ByVal department As String)
        MyBase.Selection.Department = department
    End Sub

    ''' <summary>
    ''' Update sub department
    ''' </summary>
    ''' <param name="subDepartment">Sub department</param>
    ''' <remarks></remarks>
    Public Sub UpdateSubDepartment(ByVal subDepartment As String)
        MyBase.Selection.SubDepartment = subDepartment
    End Sub

    ''' <summary>
    ''' Update emailaddress
    ''' </summary>
    ''' <param name="emailAddress">Emailaddress</param>
    ''' <remarks></remarks>
    Public Sub UpdateEmailAddress(ByVal emailAddress As String)
        MyBase.Selection.EmailAddress = emailAddress
    End Sub

    ''' <summary>
    ''' Update teammember to report to
    ''' </summary>
    ''' <param name="teamMember">Teammber to report to</param>
    ''' <remarks></remarks>
    Public Sub UpdateReportTo(ByVal teamMember As TeamMember)
        MyBase.Selection.ReportTo = teamMember
    End Sub

    ''' <summary>
    ''' Update role
    ''' </summary>
    ''' <param name="role">Teammember role for this project</param>
    ''' <remarks></remarks>
    Public Sub UpdateRole(ByVal role As Role)
        MyBase.Selection.Role = role
    End Sub

    ''' <summary>
    ''' Get selection
    ''' </summary>
    ''' <returns>Returns the teammember object</returns>
    ''' <remarks></remarks>
    Public Overrides Function GetSelection() As DataHolders.TeamMember
        Return MyBase.Selection
    End Function
End Class
