﻿Option Strict On
Option Explicit On
Option Infer Off
Imports Securex.FIT.Fitclient.Business.DataHolders

Public Class TaskEmployee
    Private Shared m_TaskEmployeeData As TaskEmployee = New TaskEmployee()

    Private Sub New()
    End Sub

    Public Shared ReadOnly Property Instance() As TaskEmployee
        Get
            Return m_TaskEmployeeData
        End Get
    End Property

    ''' <summary>
    ''' Get all employess
    ''' </summary>
    ''' <returns>Returns an IList of employees</returns>
    ''' <remarks></remarks>
    Public Function GetAllEmployees() As IList(Of Employee)
        Dim session As ISessionDao = Nothing
        Try
            session = Facade.Instance.RepositoryFactory.CreateSession()
            GetAllEmployees = Facade.Instance.RepositoryFactory.Employee.GetAllEmployees(session)
            session.CancelAndClose()
        Catch ex As RepositoryException
            If (session IsNot Nothing) Then
                session.CancelAndClose()
            End If
            Throw New Exception(ex.Message, ex.InnerException)
        End Try
    End Function

    ''' <summary>
    ''' Get empluyee by employee id
    ''' </summary>
    ''' <param name="employeeId">Employee id</param>
    ''' <returns>Returns the requested employee</returns>
    ''' <remarks></remarks>
    Public Function GetEmployeeForEmployeeID(ByVal employeeId As String) As Employee
        Dim session As ISessionDao = Nothing
        Try
            session = Facade.Instance.RepositoryFactory.CreateSession()
            GetEmployeeForEmployeeID = Facade.Instance.RepositoryFactory.Employee.GetEmployeeForEmployeeID(session, employeeId)(0)
            session.CancelAndClose()
        Catch ex As RepositoryException
            If (session IsNot Nothing) Then
                session.CancelAndClose()
            End If
            Throw New Exception(ex.Message, ex.InnerException)
        End Try
    End Function
End Class
