﻿Option Strict On
Option Explicit On
Option Infer Off
Imports Securex.FIT.Fitclient.Business.DataHolders

Public Class TaskPrivileges

    ''' <summary>
    ''' Get the privileges for employee id
    ''' </summary>
    ''' <param name="employeeId">Employee id</param>
    ''' <returns>Returns the privileges for the specified employee id</returns>
    ''' <remarks></remarks>
    Public Function GetPrivilegesForEmployeeID(ByVal employeeId As String) As Privileges
        Dim session As ISessionDao = Nothing
        Try
            session = Facade.Instance.RepositoryFactory.CreateSession()
            Dim employeePrivilegesList As IList(Of Privileges) = Facade.Instance.RepositoryFactory.Privileges.GetPrivilegesByEmployeeId(session, employeeId)
            GetPrivilegesForEmployeeID = New Privileges()
            If (employeePrivilegesList IsNot Nothing AndAlso employeePrivilegesList.Count > 0) Then
                GetPrivilegesForEmployeeID = employeePrivilegesList(0)
            End If
            session.CancelAndClose()
        Catch ex As RepositoryException
            If (session IsNot Nothing) Then
                session.CancelAndClose()
            End If
            Throw New Exception(ex.Message, ex.InnerException)
        End Try
    End Function
End Class
