﻿Option Strict On
Option Explicit On
Option Infer Off
Imports Securex.FIT.Fitclient.Business.DataHolders

Public Class TaskTeamMember
    Private m_Selection As TeamMemberSelection

    Public Sub New()
        Selection = New TeamMemberSelection()
    End Sub

    ''' <summary>
    ''' Add this teammember to the selection
    ''' </summary>
    ''' <param name="teamMember">Teammmember object</param>
    ''' <remarks></remarks>
    Public Sub Add(ByVal teamMember As TeamMember)
        Selection.Add(teamMember)
    End Sub

    ''' <summary>
    ''' Update the employee id
    ''' </summary>
    ''' <param name="id">Employee id</param>
    ''' <remarks></remarks>
    Public Sub UpdateEmployeeID(ByVal id As String)
        Selection.UpdateEmployeeID(id)
    End Sub

    ''' <summary>
    ''' Update the employee name
    ''' </summary>
    ''' <param name="name">Name of employee</param>
    ''' <remarks></remarks>
    Public Sub UpdateEmployeeName(ByVal name As String)
        Selection.UpdateEmployeeName(name)
    End Sub

    ''' <summary>
    ''' Update department
    ''' </summary>
    ''' <param name="department">Department</param>
    ''' <remarks></remarks>
    Public Sub UpdateDepartment(ByVal department As String)
        Selection.UpdateDepartment(department)
    End Sub

    ''' <summary>
    ''' Update sub department
    ''' </summary>
    ''' <param name="subDepartment">Sub department</param>
    ''' <remarks></remarks>
    Public Sub UpdateSubDepartment(ByVal subDepartment As String)
        Selection.UpdateSubDepartment(subDepartment)
    End Sub

    ''' <summary>
    ''' Update the emailaddress
    ''' </summary>
    ''' <param name="emailAddress">Emailaddress</param>
    ''' <remarks></remarks>
    Public Sub UpdateEmailAddress(ByVal emailAddress As String)
        Selection.UpdateEmailAddress(emailAddress)
    End Sub

    ''' <summary>
    ''' Update report to
    ''' </summary>
    ''' <param name="teamMember">Teammember to report to</param>
    ''' <remarks></remarks>
    Public Sub UpdateReportTo(ByVal teamMember As TeamMember)
        Selection.UpdateReportTo(teamMember)
    End Sub

    ''' <summary>
    ''' Update role
    ''' </summary>
    ''' <param name="role">Role</param>
    ''' <remarks></remarks>
    Public Sub UpdateRole(ByVal role As Role)
        Selection.UpdateRole(role)
    End Sub

    ''' <summary>
    ''' Clear the selection
    ''' </summary>
    ''' <remarks></remarks>
    Public Sub ClearSelection()
        Selection.Clear()
    End Sub

    ''' <summary>
    ''' Get the teammember in the selection
    ''' </summary>
    ''' <returns>Returns the teammember object in the selection</returns>
    ''' <remarks></remarks>
    Public Function GetSelection() As TeamMember
        Return Selection.GetSelection()
    End Function

    Private Property Selection() As TeamMemberSelection
        Get
            Return m_Selection
        End Get
        Set(ByVal value As TeamMemberSelection)
            m_Selection = value
        End Set
    End Property
End Class
