﻿Option Strict On
Option Explicit On
Option Infer Off
Imports Securex.FIT.Fitclient.Business.DataHolders

Public Class TaskWorkPackage
    Private m_Selection As WorkPackageSelection

    Public Sub New()
        Selection = New WorkPackageSelection()
    End Sub

    ''' <summary>
    ''' Add this workpackage to the selection
    ''' </summary>
    ''' <param name="workPackage">Workpackage object</param>
    ''' <remarks></remarks>
    Public Sub Add(ByVal workPackage As WorkPackage)
        Selection.Add(workPackage)
    End Sub

    ''' <summary>
    ''' Update the workpackage name
    ''' </summary>
    ''' <param name="name">Name of workpackage</param>
    ''' <remarks></remarks>
    Public Sub UpdateName(ByVal name As String)
        Selection.UpdateName(name)
    End Sub

    ''' <summary>
    ''' Update the estimated time
    ''' </summary>
    ''' <param name="estimatedTime">Expected time needed to complete the workpackage</param>
    ''' <remarks></remarks>
    Public Sub UpdateEstimatedTime(ByVal estimatedTime As String)
        Selection.UpdateEstimatedTime(estimatedTime)
    End Sub

    ''' <summary>
    ''' 
    ''' </summary>
    ''' <param name="responsibleId">Employee id</param>
    ''' <param name="responsibleName">employee name</param>
    ''' <remarks></remarks>
    Public Sub UpdateResponsible(ByVal responsibleId As String, ByVal responsibleName As String)
        Selection.UpdateResponsible(responsibleId, responsibleName)
    End Sub

    ''' <summary>
    ''' Update due date
    ''' </summary>
    ''' <param name="dueDate">Expected end date</param>
    ''' <remarks></remarks>
    Public Sub UpdateDueDate(ByVal dueDate As DateTime)
        Selection.UpdateDueDate(dueDate)
    End Sub

    ''' <summary>
    ''' Clear the selection
    ''' </summary>
    ''' <remarks></remarks>
    Public Sub ClearSelection()
        Selection.Clear()
    End Sub

    ''' <summary>
    ''' Get the workpackage in the selection
    ''' </summary>
    ''' <returns>Returns the workpackage object in the selection</returns>
    ''' <remarks></remarks>
    Public Function GetSelection() As WorkPackage
        Return Selection.GetSelection()
    End Function

    Private Property Selection() As WorkPackageSelection
        Get
            Return m_Selection
        End Get
        Set(ByVal value As WorkPackageSelection)
            m_Selection = value
        End Set
    End Property
End Class
