﻿Option Strict On
Option Explicit On
Option Infer Off
Imports Securex.FIT.Fitclient.Presenters
Imports System.Windows.Forms

Public Class FormProjectScreen2
    Implements IViewProjectScreen2, IViewDescription
    Private m_Presenter As PresenterFormProjectScreen2
    Private Const SCREEN_NAME As String = "Screen 2"

    Public Sub New()
        ' This call is required by the Windows Form Designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.
        'initialize presenter
        Presenter = New PresenterFormProjectScreen2(Me)
    End Sub

    Private Sub ExtendedRichTextBoxWhy_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExtendedRichTextBoxWhy.TextChanged
        Try
            Presenter.UpdateWhy(ExtendedRichTextBoxWhy.Text)
        Catch ex As Exception
            ShowErrorMessage(ex.Message)
        End Try
    End Sub

    Private Sub ExtendedRichTextBoxInclude_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExtendedRichTextBoxInclude.TextChanged
        Try
            Presenter.UpdateInclude(ExtendedRichTextBoxInclude.Text)
        Catch ex As Exception
            ShowErrorMessage(ex.Message)
        End Try
    End Sub

    Private Sub ExtendedRichTextBoxExclude_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExtendedRichTextBoxExclude.TextChanged
        Try
            Presenter.UpdateExclude(ExtendedRichTextBoxExclude.Text)
        Catch ex As Exception
            ShowErrorMessage(ex.Message)
        End Try
    End Sub

    Private Sub ExtendedRichTextBoxAsIs_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExtendedRichTextBoxAsIs.TextChanged
        Try
            Presenter.UpdateAsIs(ExtendedRichTextBoxAsIs.Text)
        Catch ex As Exception
            ShowErrorMessage(ex.Message)
        End Try
    End Sub

    Private Sub ExtendedRichTextBoxToBe_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExtendedRichTextBoxToBe.TextChanged
        Try
            Presenter.UpdateToBe(ExtendedRichTextBoxToBe.Text)
        Catch ex As Exception
            ShowErrorMessage(ex.Message)
        End Try
    End Sub

    Private Sub IsEditable(ByVal value As Boolean)
        ExtendedRichTextBoxWhy.ReadOnly = Not value
        ExtendedRichTextBoxInclude.ReadOnly = Not value
        ExtendedRichTextBoxExclude.ReadOnly = Not value
        ExtendedRichTextBoxAsIs.ReadOnly = Not value
        ExtendedRichTextBoxToBe.ReadOnly = Not value
    End Sub

    Private Sub ShowErrorMessage(ByVal message As String)
        MessageBox.Show(message)
    End Sub

    Private Property Presenter() As PresenterFormProjectScreen2
        Get
            Return m_Presenter
        End Get
        Set(ByVal value As PresenterFormProjectScreen2)
            m_Presenter = value
        End Set
    End Property

#Region "IViewProjectScreen2"
    Public Function GetChildPanel() As System.Windows.Forms.Panel Implements Presenters.IChildView.GetChildPanel
        Return Nothing
    End Function

    Public Sub ShowChild() Implements Presenters.IChildView.ShowChild
        Try
            Show()
            Presenter.SendChangedViewEvent()
            Presenter.RequestSelection()
        Catch ex As Exception
            ShowErrorMessage(ex.Message)
        End Try
    End Sub

    Public Sub UpdateTopLevel(ByVal value As Boolean) Implements Presenters.IChildView.UpdateTopLevel
        SetTopLevel(value)
    End Sub

    Public Function GetMainPanel() As System.Windows.Forms.Panel Implements Presenters.IChildView.GetMainPanel
        Return PanelFormProjectScreen2
    End Function

    Public Function GetToolstrip() As System.Windows.Forms.ToolStrip Implements Presenters.IChildView.GetToolstrip
        Return Nothing
    End Function

    Public Function GetText() As String Implements Presenters.IChildView.GetText
        Return SCREEN_NAME
    End Function

    Public Sub UpdateView(ByVal project As Business.DataHolders.ProjectProposalRevision) Implements Presenters.IViewProjectScreen2.UpdateView
        Try
            ExtendedRichTextBoxWhy.Text = project.Why
            ExtendedRichTextBoxInclude.Text = project.Include
            ExtendedRichTextBoxExclude.Text = project.Exclude
            ExtendedRichTextBoxAsIs.Text = project.AsIs
            ExtendedRichTextBoxToBe.Text = project.ToBe
            IsEditable(Presenter.IsEditable)
        Catch ex As Exception
            ShowErrorMessage(ex.Message)
        End Try
    End Sub

#Region "IViewFormProjectEditorChild"
    Public Function GetName() As String Implements Presenters.IViewFormProjectEditorChild.GetName
        Return Name
    End Function
#End Region
#End Region

End Class