﻿Option Strict On
Option Explicit On
Option Infer Off
Imports Securex.FIT.Fitclient.Presenters
Imports System.Windows.Forms

Public Class FormProjectScreen3
    Implements IViewProjectScreen3, IViewDescription
    Private m_Presenter As PresenterFormProjectScreen3
    Private Const SCREEN_NAME As String = "Screen 3"

    Public Sub New()
        ' This call is required by the Windows Form Designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.
        'initialize presenter
        Presenter = New PresenterFormProjectScreen3(Me)
    End Sub

    Private Sub ExtendedRichTextBoxObjectifs_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExtendedRichTextBoxObjectifs.TextChanged
        Try
            Presenter.UpdateObjectifs(ExtendedRichTextBoxObjectifs.Text)
        Catch ex As Exception
            ShowErrorMessage(ex.Message)
        End Try
    End Sub

    Private Sub ExtendedRichTextBoxCost_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExtendedRichTextBoxCost.TextChanged
        Try
            Presenter.UpdateCost(ExtendedRichTextBoxCost.Text)
        Catch ex As Exception
            ShowErrorMessage(ex.Message)
        End Try
    End Sub

    Private Sub ExtendedRichTextBoxBenefits_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExtendedRichTextBoxBenefits.TextChanged
        Try
            Presenter.UpdateBenefits(ExtendedRichTextBoxBenefits.Text)
        Catch ex As Exception
            ShowErrorMessage(ex.Message)
        End Try
    End Sub

    Private Sub ExtendedRichTextBoxAlignations_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExtendedRichTextBoxAlignations.TextChanged
        Try
            Presenter.UpdateAlignation(ExtendedRichTextBoxAlignations.Text)
        Catch ex As Exception
            ShowErrorMessage(ex.Message)
        End Try
    End Sub

    Private Sub IsEditable(ByVal value As Boolean)
        ExtendedRichTextBoxObjectifs.ReadOnly = Not value
        ExtendedRichTextBoxCost.ReadOnly = Not value
        ExtendedRichTextBoxBenefits.ReadOnly = Not value
        ExtendedRichTextBoxAlignations.ReadOnly = Not value
    End Sub

    Private Sub ShowErrorMessage(ByVal message As String)
        MessageBox.Show(message)
    End Sub

    Private Property Presenter() As PresenterFormProjectScreen3
        Get
            Return m_Presenter
        End Get
        Set(ByVal value As PresenterFormProjectScreen3)
            m_Presenter = value
        End Set
    End Property

#Region "IViewProjectScreen3"
    Public Function GetChildPanel() As System.Windows.Forms.Panel Implements Presenters.IChildView.GetChildPanel
        Return Nothing
    End Function

    Public Sub ShowChild() Implements Presenters.IChildView.ShowChild
        Try
            Show()
            Presenter.SendChangedViewEvent()
            Presenter.RequestSelection()
        Catch ex As Exception
            ShowErrorMessage(ex.Message)
        End Try
    End Sub

    Public Sub UpdateTopLevel(ByVal value As Boolean) Implements Presenters.IChildView.UpdateTopLevel
        SetTopLevel(value)
    End Sub

    Public Function GetMainPanel() As System.Windows.Forms.Panel Implements Presenters.IChildView.GetMainPanel
        Return PanelFormProjectScreen3
    End Function

    Public Function GetToolstrip() As System.Windows.Forms.ToolStrip Implements Presenters.IChildView.GetToolstrip
        Return Nothing
    End Function

    Public Function GetText() As String Implements Presenters.IChildView.GetText
        Return SCREEN_NAME
    End Function

    Public Sub UpdateView(ByVal project As Business.DataHolders.ProjectProposalRevision) Implements Presenters.IViewProjectScreen3.UpdateView
        Try
            ExtendedRichTextBoxObjectifs.Text = project.Objectifs
            ExtendedRichTextBoxCost.Text = project.Cost
            ExtendedRichTextBoxBenefits.Text = project.Benefits
            ExtendedRichTextBoxAlignations.Text = project.Alignation
            IsEditable(Presenter.IsEditable)
        Catch ex As Exception
            ShowErrorMessage(ex.Message)
        End Try
    End Sub

#Region "IViewFormProjectEditorChild"
    Public Function GetName() As String Implements Presenters.IViewFormProjectEditorChild.GetName
        Return Name
    End Function
#End Region
#End Region

End Class