﻿Option Strict On
Option Explicit On
Option Infer Off
Imports Securex.FIT.Fitclient.Presenters

Public Class FormProjectScreen4
    Implements IViewProjectScreen4, IViewDescription
    Private m_Presenter As PresenterFormProjectScreen4
    Private m_FormTiming_WorkPackage As FormTiming_Team
    Private m_FormWorkPackageEditor As FormWorkPackageEditor
    Private m_FormMilestoneEditor As FormMilestoneEditor
    Private m_FormTeamMemberEditor As FormTeamMemberEditor
    Private m_ChildViews As IDictionary(Of String, IChildView)
    Private Const SCREEN_NAME As String = "Screen 4"

    Public Sub New()
        ' This call is required by the Windows Form Designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.
        'initialize dictionary
        ChildViews = New Dictionary(Of String, IChildView)

        'initialize forms and add to list
        ChildViews.Add(PresenterFormProjectScreen4.TIMING_TEAM, New FormTiming_Team())
        ChildViews.Add(PresenterFormProjectScreen4.WORK_PACKAGE_EDITOR, WorkPackageEditor())
        ChildViews.Add(PresenterFormProjectScreen4.MILESTONE_EDITOR, MilestoneEditor())
        ChildViews.Add(PresenterFormProjectScreen4.TEAM_MEMBER_EDITOR, TeamMemberEditor())

        'initialize presenter
        Presenter = New PresenterFormProjectScreen4(Me, ChildViews)
    End Sub

    Private Property Presenter() As PresenterFormProjectScreen4
        Get
            Return m_Presenter
        End Get
        Set(ByVal value As PresenterFormProjectScreen4)
            m_Presenter = value
        End Set
    End Property

    Private Property ChildViews() As IDictionary(Of String, IChildView)
        Get
            Return m_ChildViews
        End Get
        Set(ByVal value As IDictionary(Of String, IChildView))
            m_ChildViews = value
        End Set
    End Property

    Private Property WorkPackageEditor() As FormWorkPackageEditor
        Get
            Return m_FormWorkPackageEditor
        End Get
        Set(ByVal value As FormWorkPackageEditor)
            m_FormWorkPackageEditor = value
        End Set
    End Property

    Private Property MilestoneEditor() As FormMilestoneEditor
        Get
            Return m_FormMilestoneEditor
        End Get
        Set(ByVal value As FormMilestoneEditor)
            m_FormMilestoneEditor = value
        End Set
    End Property

    Private Property TeamMemberEditor() As FormTeamMemberEditor
        Get
            Return m_FormTeamMemberEditor
        End Get
        Set(ByVal value As FormTeamMemberEditor)
            m_FormTeamMemberEditor = value
        End Set
    End Property

#Region "IViewProjectScreen4"
    Public Function GetChildPanel() As System.Windows.Forms.Panel Implements Presenters.IChildView.GetChildPanel
        Return GetMainPanel()
    End Function

    Public Sub ShowChild() Implements Presenters.IChildView.ShowChild
        Show()
        Presenter.SendChangedViewEvent()
        Presenter.ShowDefaultScreen()
    End Sub

    Public Sub UpdateTopLevel(ByVal value As Boolean) Implements Presenters.IChildView.UpdateTopLevel
        SetTopLevel(value)
    End Sub

    Public Function GetMainPanel() As System.Windows.Forms.Panel Implements Presenters.IChildView.GetMainPanel
        Return PanelMain
    End Function

    Public Function GetToolstrip() As System.Windows.Forms.ToolStrip Implements Presenters.IChildView.GetToolstrip
        Return Nothing
    End Function

    Public Function GetText() As String Implements Presenters.IChildView.GetText
        Return SCREEN_NAME
    End Function

    Public Sub CreateWorkPackageEditor(ByVal workPackage As Business.DataHolders.WorkPackage) Implements Presenters.IViewProjectScreen4.CreateWorkPackageEditor
        If (workPackage IsNot Nothing) Then
            WorkPackageEditor = New FormWorkPackageEditor(workPackage)
        Else
            WorkPackageEditor = New FormWorkPackageEditor()
        End If
    End Sub

    Public Function GetWorkPackageEditor() As Presenters.IViewFormWorkPackageEditor Implements Presenters.IViewProjectScreen4.GetWorkPackageEditor
        Return WorkPackageEditor
    End Function

    Public Sub CloseWorkPackageEditor() Implements Presenters.IViewProjectScreen4.CloseWorkPackageEditor
        WorkPackageEditor = Nothing
    End Sub

    Public Sub CreateMilestoneEditor(ByVal workPackageName As String, ByVal milestone As Business.DataHolders.Milestone) Implements Presenters.IViewProjectScreen4.CreateMilestoneEditor
        If (milestone IsNot Nothing) Then
            MilestoneEditor = New FormMilestoneEditor(workPackageName, milestone)
        Else
            MilestoneEditor = New FormMilestoneEditor(workPackageName)
        End If
    End Sub

    Public Function GetMilestoneEditor() As Presenters.IViewFormMilestoneEditor Implements Presenters.IViewProjectScreen4.GetMilestoneEditor
        Return MilestoneEditor
    End Function

    Public Sub CloseMilestoneEditor() Implements Presenters.IViewProjectScreen4.CloseMilestoneEditor
        MilestoneEditor = Nothing
    End Sub

    Public Sub CreateTeamMemberEditor(ByVal teamMember As Business.DataHolders.TeamMember) Implements Presenters.IViewProjectScreen4.CreateTeamMemberEditor
        If (teamMember IsNot Nothing) Then
            TeamMemberEditor = New FormTeamMemberEditor(teamMember)
        Else
            TeamMemberEditor = New FormTeamMemberEditor()
        End If
    End Sub

    Public Function GetTeamMemberEditor() As Presenters.IViewFormTeamMemberEditor Implements Presenters.IViewProjectScreen4.GetTeamMemberEditor
        Return TeamMemberEditor
    End Function

    Public Sub CloseTeamMemberEditor() Implements Presenters.IViewProjectScreen4.CloseTeamMemberEditor
        TeamMemberEditor = Nothing
    End Sub

    Public Function GetName() As String Implements Presenters.IViewFormProjectEditorChild.GetName
        Return Name
    End Function
#End Region

End Class