﻿Option Strict On
Option Explicit On
Option Infer Off
Imports Securex.FIT.Fitclient.Presenters
Imports System.Windows.Forms

Public Class FormProjectScreen5
    Implements IViewProjectScreen5, IViewDescription
    Private m_Presenter As PresenterFormProjectScreen5
    Private Const SCREEN_NAME As String = "Screen 5"

    Public Sub New()
        ' This call is required by the Windows Form Designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.
        'initialize presenter
        Presenter = New PresenterFormProjectScreen5(Me)
    End Sub

    Private Sub ExtendedRichTextBoxPreconditions_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExtendedRichTextBoxPreconditions.TextChanged
        Try
            Presenter.UpdatePreconditions(ExtendedRichTextBoxPreconditions.Text)
        Catch ex As Exception
            ShowErrorMessage(ex.Message)
        End Try
    End Sub

    Private Sub ExtendedRichTextBoxConstraints_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExtendedRichTextBoxConstraints.TextChanged
        Try
            Presenter.UpdateConstraints(ExtendedRichTextBoxConstraints.Text)
        Catch ex As Exception
            ShowErrorMessage(ex.Message)
        End Try
    End Sub

    Private Sub ExtendedRichTextBoxDependencies_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExtendedRichTextBoxDependencies.TextChanged
        Try
            Presenter.UpdateDependencies(ExtendedRichTextBoxDependencies.Text)
        Catch ex As Exception
            ShowErrorMessage(ex.Message)
        End Try
    End Sub

    Private Sub ExtendedRichTextBoxRisk_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExtendedRichTextBoxRisk.TextChanged
        Try
            Presenter.UpdateRisk(ExtendedRichTextBoxRisk.Text)
        Catch ex As Exception
            ShowErrorMessage(ex.Message)
        End Try
    End Sub

    Private Sub ExtendedRichTextBoxSupport_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExtendedRichTextBoxSupport.TextChanged
        Try
            Presenter.UpdateSupport(ExtendedRichTextBoxSupport.Text)
        Catch ex As Exception
            ShowErrorMessage(ex.Message)
        End Try
    End Sub

    Private Sub IsEditable(ByVal value As Boolean)
        ExtendedRichTextBoxPreconditions.ReadOnly = Not value
        ExtendedRichTextBoxConstraints.ReadOnly = Not value
        ExtendedRichTextBoxDependencies.ReadOnly = Not value
        ExtendedRichTextBoxRisk.ReadOnly = Not value
        ExtendedRichTextBoxSupport.ReadOnly = Not value
    End Sub

    Private Sub ShowErrorMessage(ByVal message As String)
        MessageBox.Show(message)
    End Sub

    Private Property Presenter() As PresenterFormProjectScreen5
        Get
            Return m_Presenter
        End Get
        Set(ByVal value As PresenterFormProjectScreen5)
            m_Presenter = value
        End Set
    End Property

#Region "IViewProjectScreen5"
    Public Function GetChildPanel() As System.Windows.Forms.Panel Implements Presenters.IChildView.GetChildPanel
        Return Nothing
    End Function

    Public Sub ShowChild() Implements Presenters.IChildView.ShowChild
        Try
            Show()
            Presenter.SendChangedViewEvent()
            Presenter.RequestSelection()
        Catch ex As Exception
            ShowErrorMessage(ex.Message)
        End Try
    End Sub

    Public Sub UpdateTopLevel(ByVal value As Boolean) Implements Presenters.IChildView.UpdateTopLevel
        SetTopLevel(value)
    End Sub

    Public Function GetMainPanel() As System.Windows.Forms.Panel Implements Presenters.IChildView.GetMainPanel
        Return PanelFormProjectScreen5
    End Function

    Public Function GetToolstrip() As System.Windows.Forms.ToolStrip Implements Presenters.IChildView.GetToolstrip
        Return Nothing
    End Function

    Public Function GetText() As String Implements Presenters.IChildView.GetText
        Return SCREEN_NAME
    End Function

    Public Function GetName() As String Implements Presenters.IViewFormProjectEditorChild.GetName
        Return Name
    End Function

    Public Sub UpdateView(ByVal project As Business.DataHolders.ProjectProposalRevision) Implements Presenters.IViewProjectScreen5.UpdateView
        Try
            ExtendedRichTextBoxPreconditions.Text = project.Preconditions
            ExtendedRichTextBoxConstraints.Text = project.Constraints
            ExtendedRichTextBoxDependencies.Text = project.Dependencies
            ExtendedRichTextBoxRisk.Text = project.Risk
            ExtendedRichTextBoxSupport.Text = project.Support
            IsEditable(Presenter.IsEditable)
        Catch ex As Exception
            ShowErrorMessage(ex.Message)
        End Try
    End Sub
#End Region

End Class