﻿Option Strict On
Option Explicit On
Option Infer Off
Imports CustomControls
Imports System.Windows.Forms

Public Class ExtendedListviewComparator
    Implements IComparer(Of FourStateListViewItem)

    Private m_Order As SortOrder
    Private m_ColumnIndex As Int32
    Private m_Comparer As CaseInsensitiveComparer

    Public Sub New()
        Order = SortOrder.None
        m_Comparer = New CaseInsensitiveComparer()
    End Sub

    Public Property Order() As SortOrder
        Get
            Return m_Order
        End Get
        Set(ByVal value As SortOrder)
            m_Order = value
        End Set
    End Property

    Public Property ColumnIndex() As Int32
        Get
            Return m_ColumnIndex
        End Get
        Set(ByVal value As Int32)
            m_ColumnIndex = value
        End Set
    End Property

    Public Function Compare(ByVal x As CustomControls.FourStateListViewItem, ByVal y As CustomControls.FourStateListViewItem) As Integer Implements System.Collections.Generic.IComparer(Of CustomControls.FourStateListViewItem).Compare
        Dim result As Int32
        Dim value1 As String = String.Empty
        Dim value2 As String = String.Empty

        If (x IsNot Nothing AndAlso x.SubItems.Count > ColumnIndex) Then
            value1 = x.SubItems(ColumnIndex).Text
        End If

        If (y IsNot Nothing AndAlso y.SubItems.Count > ColumnIndex) Then
            value2 = y.SubItems(ColumnIndex).Text
        End If

        result = m_Comparer.Compare(value1, value2)

        If (Order = SortOrder.Descending) Then
            result *= -1
        End If

        Return result
    End Function
End Class
