﻿Option Strict On
Option Explicit On
Option Infer Off
Imports System.Reflection
Imports Securex.FIT.Fitclient.Business
Imports Securex.FIT.Fitclient.Business.DataHolders

Public Class PresenterFormPartDescriptionEditor
    Private m_View As IViewFormPartDescriptionEditor

    Public Sub New(ByVal view As IViewFormPartDescriptionEditor)
        MyClass.View = view
    End Sub

    Public Sub Save()
        Try
            TaskFormDescription.Instance.Save()
            TaskFormDescription.Instance.ClearSelection()
            CloseView()
        Catch ex As Exception
            Throw New Exception(ex.Message)
        End Try
    End Sub

    Public Sub Cancel()
        CloseView()
    End Sub

    Public Sub SetSelection(ByVal formDescription As FormDescription)
        TaskFormDescription.Instance.Add(formDescription)
    End Sub

    Public Sub UpdateSelelection(ByVal description As String, ByVal formName As String)
        TaskFormDescription.Instance.UpdateFormDescription(description, formName)
    End Sub

    Public Sub SendChangedViewEvent()
        DispatcherChangedViewEvent.SendChangedViewEvent(Me, New ChangedViewEvent(View.GetText(), Nothing))
    End Sub

    Public Function GetAllProjectFormNames() As IList(Of String)
        Dim formNames As IList(Of String) = New List(Of String)()
        Dim assemblies As IList(Of Assembly) = AppDomain.CurrentDomain.GetAssemblies()
        Dim assemblyEumerator As IEnumerator(Of Assembly) = assemblies.GetEnumerator()
        While (assemblyEumerator.MoveNext())
            Dim types As IList(Of Type) = assemblyEumerator.Current.GetTypes()
            Dim typeEumerator As IEnumerator(Of Type) = types.GetEnumerator()
            While (typeEumerator.MoveNext())
                If (typeEumerator.Current.IsPublic AndAlso typeEumerator.Current.GetInterface(GetType(IViewDescription).ToString()) IsNot Nothing) Then
                    formNames.Add(typeEumerator.Current.Name)
                End If
            End While
        End While
        Return formNames
    End Function

    Public Sub RequestDescriptionForForm(ByVal formName As String)
        Try
            Dim formDescription As FormDescription = TaskFormDescription.Instance.GetDescriptionByFormName(formName)
            If (formDescription.FormName Is Nothing) Then
                formDescription.FormName = formName
            End If
            TaskFormDescription.Instance.Add(formDescription)
            View.UpdateView(formDescription)
        Catch ex As Exception
            Throw New Exception(ex.Message)
        End Try
    End Sub

    Private Sub CloseView()
        DispatcherClosedViewEvent.SendClosedViewEvent(Me, Nothing)
    End Sub

    Private Property View() As IViewFormPartDescriptionEditor
        Get
            Return m_View
        End Get
        Set(ByVal value As IViewFormPartDescriptionEditor)
            m_View = value
        End Set
    End Property
End Class
