﻿Option Strict On
Option Explicit On
Option Infer Off
Imports Securex.FIT.Fitclient.Business

Public Class PresenterFormProjectScreen6
    Private m_View As IViewProjectScreen6
    Private m_Task As TaskWord

    Public Sub New(ByVal view As IViewProjectScreen6)
        MyClass.View = view
        Task = New TaskWord()
    End Sub

    Public Sub Save(ByVal filename As String)
        Task.Save(filename)
    End Sub

    Public Function GetPreview() As String
        Try
            Return Task.GetPreview()
        Catch ex As Exception
            ThrowException(ex)
        End Try
    End Function

    Public Function ShowChanges() As String
        Try
            Return TaskDiff.Instance.ShowChanges()
        Catch ex As Exception
            ThrowException(ex)
        End Try
    End Function

    Public Sub RequestSelection()
        Try
            View.UpdateView()
        Catch ex As Exception
            ThrowException(ex)
        End Try
    End Sub

    Public ReadOnly Property IsEditable() As Boolean
        Get
            Return TaskProjectProposalRevision.Instance.GetSelection().PreviousRevisionId IsNot Nothing
        End Get
    End Property

    Public Sub SendChangedViewEvent()
        DispatcherChangedViewEvent.SendChangedViewEvent(Me, New ChangedViewEvent(View.GetText(), TaskFormDescription.Instance.GetDescriptionByFormName(View.GetName()).Description))
    End Sub

    Private Sub ThrowException(ByVal exception As Exception)
        Throw New Exception(exception.Message)
    End Sub

    Private Property View() As IViewProjectScreen6
        Get
            Return m_View
        End Get
        Set(ByVal value As IViewProjectScreen6)
            m_View = value
        End Set
    End Property

    Private Property Task() As TaskWord
        Get
            Return m_Task
        End Get
        Set(ByVal value As TaskWord)
            m_Task = value
        End Set
    End Property
End Class
