﻿Option Strict On
Option Explicit On
Option Infer Off
Imports Securex.FIT.Fitclient.Business
Imports Securex.FIT.Fitclient.Business.DataHolders

Public Class PresenterFormRoleEditor
    Private m_View As IViewFormRoleEditor

    Public Sub New(ByVal view As IViewFormRoleEditor)
        MyClass.View = view
    End Sub

    Public Sub Save()
        Try
            TaskRole.Instance.Save()
            TaskRole.Instance.ClearSelection()
            CloseView()
        Catch ex As Exception
            Throw New Exception(ex.Message)
        End Try
    End Sub

    Public Sub Cancel()
        CloseView()
    End Sub

    Public Sub SetSelection(ByVal role As Role)
        TaskRole.Instance.Add(role)
    End Sub

    Public Sub UpdateSelelection(ByVal name As String)
        TaskRole.Instance.UpdateName(name)
    End Sub

    Public Sub SendChangedViewEvent()
        DispatcherChangedViewEvent.SendChangedViewEvent(Me, New ChangedViewEvent(View.GetText(), Nothing))
    End Sub

    Public Sub RequestRole(ByVal id As Integer)
        Try
            Dim role As Role = TaskRole.Instance.GetRoleById(id)
            If (role Is Nothing) Then
                role = New Role()
            End If
            TaskRole.Instance.Add(role)
            View.UpdateView(role)
        Catch ex As Exception
            Throw New Exception(ex.Message)
        End Try
    End Sub

    Private Sub CloseView()
        DispatcherClosedViewEvent.SendClosedViewEvent(Me, Nothing)
    End Sub

    Private Property View() As IViewFormRoleEditor
        Get
            Return m_View
        End Get
        Set(ByVal value As IViewFormRoleEditor)
            m_View = value
        End Set
    End Property
End Class
