﻿Option Strict On
Option Explicit On
Option Infer Off
Imports Securex.FIT.Fitclient.Business
Imports Securex.FIT.Fitclient.Business.DataHolders

Public Class PresenterFormSubCategoryEditor
    Private m_View As IViewFormSubCategoryEditor

    Public Sub New(ByVal view As IViewFormSubCategoryEditor)
        Try
            MyClass.View = view
            Dim categories As IList(Of Category) = TaskCategory.Instance.GetAllCategories()
        Catch ex As Exception
            Throw New Exception(ex.Message)
        End Try
    End Sub

    Public Sub Save()
        Try
            TaskSubCategory.Instance.Save()
            TaskSubCategory.Instance.ClearSelection()
            CloseView()
        Catch ex As Exception
            Throw New Exception(ex.Message)
        End Try
    End Sub

    Public Sub Cancel()
        CloseView()
    End Sub

    Public Sub SetSelection(ByVal subCategory As SubCategory)
        TaskSubCategory.Instance.Add(subCategory)
    End Sub

    Public Sub UpdateSelelection(ByVal description As String)
        TaskSubCategory.Instance.UpdateSubCategory(description)
    End Sub

    Public Sub SendChangedViewEvent()
        DispatcherChangedViewEvent.SendChangedViewEvent(Me, New ChangedViewEvent(View.GetText(), Nothing))
    End Sub

    Public Sub RequestSubCategoryDescription(ByVal description As String)
        Try
            Dim subCategory As SubCategory = TaskSubCategory.Instance.GetSubCategoryByDescription(description)
            TaskSubCategory.Instance.Add(subCategory)
            View.UpdateView(subCategory)
        Catch ex As Exception
            Throw New Exception(ex.Message)
        End Try
    End Sub

    Private Sub CloseView()
        DispatcherClosedViewEvent.SendClosedViewEvent(Me, Nothing)
    End Sub

    Private Property View() As IViewFormSubCategoryEditor
        Get
            Return m_View
        End Get
        Set(ByVal value As IViewFormSubCategoryEditor)
            m_View = value
        End Set
    End Property
End Class
