﻿Option Strict On
Option Explicit On
Option Infer Off
Imports Securex.FIT.Fitclient.Business
Imports Securex.FIT.Fitclient.Business.DataHolders
Imports System.Windows.Forms
Imports CustomControls

Public Class PresenterFormTiming_Team
    Private m_View As IViewFormTiming_Team
    Private m_SelectedWorkPackageName As String

    Public Sub New(ByVal view As IViewFormTiming_Team)
        MyClass.View = view
    End Sub

    Public Sub RequestAllWorkPackages()
        Try
            View.ClearExtendedListViewWorkPackages()
            Dim workPackages As IList(Of WorkPackage) = TaskProjectProposalRevision.Instance.GetCurrentProjectProposalRevision.WorkPackages
            If (workPackages IsNot Nothing) Then
                Dim enumerator As IEnumerator(Of WorkPackage) = workPackages.GetEnumerator()
                While (enumerator.MoveNext())
                    Dim fourstateListViewItem As FourStateListViewItem = New FourStateListViewItem()
                    fourstateListViewItem.Text = enumerator.Current.Name
                    fourstateListViewItem.Tag = enumerator.Current.Id
                    fourstateListViewItem.SubItems.Add(New ListViewItem.ListViewSubItem(fourstateListViewItem, enumerator.Current.EstimatedTime))
                    fourstateListViewItem.SubItems.Add(New ListViewItem.ListViewSubItem(fourstateListViewItem, enumerator.Current.ResponsibleName))
                    fourstateListViewItem.SubItems.Add(New ListViewItem.ListViewSubItem(fourstateListViewItem, enumerator.Current.DueDate.ToShortDateString()))
                    View.AddToExtendedListViewWorkPackages(fourstateListViewItem)
                End While
            End If
            View.UpdateWorkPackages()
        Catch ex As Exception
            ThrowException(ex)
        End Try
    End Sub

    Public Sub RequestMilestonesForWorkPackage(ByVal workPackageName As String)
        Try
            View.ClearExtendedListViewMilestones()
            Dim milestoness As IList(Of Milestone) = TaskProjectProposalRevision.Instance.GetMilestonesForWorkPackage(workPackageName)
            If (milestoness IsNot Nothing) Then
                Dim enumerator As IEnumerator(Of Milestone) = milestoness.GetEnumerator()
                While (enumerator.MoveNext())
                    Dim fourstateListViewItem As FourStateListViewItem = New FourStateListViewItem()
                    fourstateListViewItem.Text = enumerator.Current.Name
                    fourstateListViewItem.Tag = enumerator.Current.Id
                    fourstateListViewItem.SubItems.Add(New ListViewItem.ListViewSubItem(fourstateListViewItem, enumerator.Current.Description))
                    fourstateListViewItem.SubItems.Add(New ListViewItem.ListViewSubItem(fourstateListViewItem, enumerator.Current.BeginDate.ToShortDateString()))
                    fourstateListViewItem.SubItems.Add(New ListViewItem.ListViewSubItem(fourstateListViewItem, enumerator.Current.EndDate.ToShortDateString()))
                    View.AddToExtendedListViewMilestones(fourstateListViewItem)
                End While
            End If
            View.UpdateMileStones()
        Catch ex As Exception
            ThrowException(ex)
        End Try
    End Sub

    Public Sub RequestAllTeamMembers()
        Try
            View.ClearExtendedListViewTeamMembers()
            Dim teamMembers As IList(Of TeamMember) = TaskProjectProposalRevision.Instance.GetCurrentProjectProposalRevision.TeamMembers
            If (teamMembers IsNot Nothing) Then
                Dim enumerator As IEnumerator(Of TeamMember) = teamMembers.GetEnumerator()
                While (enumerator.MoveNext())
                    Dim fourstateListViewItem As FourStateListViewItem = New FourStateListViewItem()
                    fourstateListViewItem.Text = enumerator.Current.EmployeeId
                    fourstateListViewItem.Tag = enumerator.Current.Id
                    fourstateListViewItem.SubItems.Add(New ListViewItem.ListViewSubItem(fourstateListViewItem, enumerator.Current.EmployeeName))
                    fourstateListViewItem.SubItems.Add(New ListViewItem.ListViewSubItem(fourstateListViewItem, enumerator.Current.Department))
                    fourstateListViewItem.SubItems.Add(New ListViewItem.ListViewSubItem(fourstateListViewItem, enumerator.Current.SubDepartment))
                    fourstateListViewItem.SubItems.Add(New ListViewItem.ListViewSubItem(fourstateListViewItem, enumerator.Current.EmailAddress))
                    'role
                    Dim role As Role = enumerator.Current.Role
                    Dim subItemRole As ListViewItem.ListViewSubItem = New ListViewItem.ListViewSubItem(fourstateListViewItem, Nothing)
                    If (role IsNot Nothing) Then
                        subItemRole.Text = enumerator.Current.Role.Name
                        subItemRole.Tag = enumerator.Current.Role.Id
                    End If
                    fourstateListViewItem.SubItems.Add(subItemRole)
                    'report to
                    Dim reportToTeamMember As TeamMember = enumerator.Current.ReportTo
                    Dim subItemReportTo As ListViewItem.ListViewSubItem = New ListViewItem.ListViewSubItem(fourstateListViewItem, Nothing)
                    If (reportToTeamMember IsNot Nothing) Then
                        subItemReportTo.Text = enumerator.Current.ReportTo.EmployeeName
                        subItemReportTo.Tag = enumerator.Current.ReportTo.Id
                    End If
                    fourstateListViewItem.SubItems.Add(subItemReportTo)
                    View.AddToExtendedListViewTeamMembers(fourstateListViewItem)
                End While
            End If
            View.UpdateTeamMembers()
        Catch ex As Exception
            ThrowException(ex)
        End Try
    End Sub

    Public Sub RequestSelection()
        Try
            View.UpdateView()
        Catch ex As Exception
            ThrowException(ex)
        End Try
    End Sub

    Public Sub RemoveWorkPackage(ByVal name As String)
        Try
            TaskProjectProposalRevision.Instance.RemoveWorkPackage(name)
        Catch ex As Exception
            ThrowException(ex)
        End Try
    End Sub

    Public Sub RemoveTeamMember(ByVal employeeId As String)
        Try
            TaskProjectProposalRevision.Instance.RemoveTeamMember(employeeId)
        Catch ex As Exception
            ThrowException(ex)
        End Try
    End Sub

    Public Sub Close()
        DispatcherClosedViewEvent.SendClosedViewEvent(Me, New ClosedViewEvent())
    End Sub

    Public Sub ShowWorkPackageEditor(ByVal workPackageName As String)
        Try
            Dim workPackage As WorkPackage = TaskProjectProposalRevision.Instance.GetWorkPackageByName(workPackageName)
            DispatcherOpenWorkPackageEditorViewEvent.SendOpenWorkPackageEditorViewEvent(Me, New OpenEditorViewEvent(Of WorkPackage)(PresenterFormProjectScreen4.WORK_PACKAGE_EDITOR, workPackage))
        Catch ex As Exception
            ThrowException(ex)
        End Try
    End Sub

    Public Sub ShowMilestoneEditor(ByVal milestoneName As String)
        Try
            Dim milestone As Milestone = TaskProjectProposalRevision.Instance.GetMilestoneByName(SelectedWorkPackageName, milestoneName)
            DispatcherOpenMilestoneEditorViewEvent.SendOpenMilestoneEditorViewEvent(Me, New OpenEditorViewEvent(Of Milestone)(PresenterFormProjectScreen4.MILESTONE_EDITOR, milestone, SelectedWorkPackageName))
        Catch ex As Exception
            ThrowException(ex)
        End Try
    End Sub

    Public Sub ShowTeamMemberEditor(ByVal employeeId As String)
        Try
            Dim teamMember As TeamMember = TaskProjectProposalRevision.Instance.GetTeamMemberByEmployeeId(employeeId)
            DispatcherOpenTeamMemberEditorViewEvent.SendOpenTeamMemberEditorViewEvent(Me, New OpenEditorViewEvent(Of TeamMember)(PresenterFormProjectScreen4.TEAM_MEMBER_EDITOR, teamMember))
        Catch ex As Exception
            ThrowException(ex)
        End Try
    End Sub

    Public Sub SendChangedViewEvent()
        DispatcherChangedViewEvent.SendChangedViewEvent(Me, New ChangedViewEvent(View.GetText(), Nothing))
    End Sub

    Public Property SelectedWorkPackageName() As String
        Get
            Return m_SelectedWorkPackageName
        End Get
        Set(ByVal value As String)
            m_SelectedWorkPackageName = value
        End Set
    End Property

    Public ReadOnly Property IsEditable() As Boolean
        Get
            Return TaskProjectProposalRevision.Instance.IsEditable()
        End Get
    End Property

    Private Sub ThrowException(ByVal exception As Exception)
        Throw New Exception(exception.Message, exception.InnerException)
    End Sub

    Private Property View() As IViewFormTiming_Team
        Get
            Return m_View
        End Get
        Set(ByVal value As IViewFormTiming_Team)
            m_View = value
        End Set
    End Property
End Class
