﻿Option Strict On
Option Explicit On
Option Infer Off
Imports Securex.FIT.Fitclient.Business
Imports Securex.FIT.Fitclient.Business.DataHolders
Imports NHibernate
Imports NHibernate.Criterion

Public Class SqlPrivileges
    Implements IPrivileges
    Private Const EMPLOYEEID As String = "EmployeeId"
    Private m_GenericNhbDao As GenericNhbDao(Of Privileges)

    Public Sub New()
        m_GenericNhbDao = New GenericNhbDao(Of Privileges)()
    End Sub

#Region "IPrivileges"
    ''' <summary>
    ''' Get the privileges of the employee for this project
    ''' </summary>
    ''' <param name="session">Object containing the session to the database</param>
    ''' <param name="employeeId">Employee id</param>
    ''' <returns>Returns an IList of privileges</returns>
    ''' <remarks></remarks>
    Public Function GetPrivilegesByEmployeeId(ByVal session As Business.ISessionDao, ByVal employeeId As String) As System.Collections.Generic.IList(Of Business.DataHolders.Privileges) Implements Business.IPrivileges.GetPrivilegesByEmployeeId
        Try
            Dim orders As Order() = {New Order(SqlPrivileges.EMPLOYEEID, True)}
            Dim criterions As ICriterion() = {New LikeExpression(SqlPrivileges.EMPLOYEEID, employeeId, MatchMode.Exact)}
            Return m_GenericNhbDao.GetForCriteria(DirectCast(session, SqlSession).Session, criterions, orders)
        Catch ex As NHibernateException
            Throw New RepositoryException(ex.Message, ex.InnerException)
        End Try
    End Function
#End Region

End Class
