﻿Option Strict On
Option Explicit On
Option Infer Off
Imports Securex.FIT.Fitclient.Business
Imports Securex.FIT.Fitclient.Business.DataHolders
Imports NHibernate
Imports NHibernate.Criterion

Public Class SqlRevisionStatus
    Implements IRevisionStatusDao
    Private Const ID As String = "Id"
    Private Const NAME As String = "Name"
    Private m_GenericNhbDao As GenericNhbDao(Of RevisionStatus)

    Public Sub New()
        m_GenericNhbDao = New GenericNhbDao(Of RevisionStatus)()
    End Sub

#Region "IRevisionStatusDao"
    ''' <summary>
    ''' Get all revision statuses
    ''' </summary>
    ''' <param name="session">Object containing the session to the database</param>
    ''' <returns>Returns an IList of roles</returns>
    ''' <remarks></remarks>
    Public Function GetAllRevisionStatuses(ByVal session As Business.ISessionDao) As System.Collections.Generic.IList(Of Business.DataHolders.RevisionStatus) Implements Business.IRevisionStatusDao.GetAllRevisionStatuses
        Try
            GetAllRevisionStatuses = m_GenericNhbDao.GetAll(DirectCast(session, SqlSession).Session)
        Catch ex As NHibernateException
            Throw New RepositoryException(ex.Message, ex.InnerException)
        End Try
    End Function

    ''' <summary>
    ''' Get revision status by row identifier
    ''' </summary>
    ''' <param name="session">Object containing the session to the database</param>
    ''' <param name="id">Row identifier</param>
    ''' <returns>Returns an IList of roles</returns>
    ''' <remarks></remarks>
    Public Function GetRevisionStatusById(ByVal session As Business.ISessionDao, ByVal id As Integer) As System.Collections.Generic.IList(Of Business.DataHolders.RevisionStatus) Implements Business.IRevisionStatusDao.GetRevisionStatusById
        Try
            Dim orders As Order() = {New Order(SqlRevisionStatus.ID, True)}
            Dim criterions As ICriterion() = {New LikeExpression(SqlRevisionStatus.ID, id.ToString(), MatchMode.Exact)}
            Return m_GenericNhbDao.GetForCriteria(DirectCast(session, SqlSession).Session, criterions, orders)
        Catch ex As NHibernateException
            Throw New RepositoryException(ex.Message, ex.InnerException)
        End Try
    End Function

    ''' <summary>
    ''' Get revision status by name
    ''' </summary>
    ''' <param name="session">Object containing the session to the database</param>
    ''' <param name="name">Revision name</param>
    ''' <returns>Returns an IList of roles</returns>
    ''' <remarks></remarks>
    Public Function GetRevisionStatusByName(ByVal session As Business.ISessionDao, ByVal name As String) As System.Collections.Generic.IList(Of Business.DataHolders.RevisionStatus) Implements Business.IRevisionStatusDao.GetRevisionStatusByName
        Try
            Dim orders As Order() = {New Order(SqlRevisionStatus.NAME, True)}
            Dim criterions As ICriterion() = {New LikeExpression(SqlRevisionStatus.NAME, name, MatchMode.Exact)}
            Return m_GenericNhbDao.GetForCriteria(DirectCast(session, SqlSession).Session, criterions, orders)
        Catch ex As NHibernateException
            Throw New RepositoryException(ex.Message, ex.InnerException)
        End Try
    End Function
#End Region

End Class
