﻿Option Strict On
Option Explicit On
Option Infer Off
Imports NHibernate
Imports NHibernate.Cfg
Imports Securex.FIT.Fitclient.Business
Imports System.Configuration
Imports System.Reflection

Public Class SqlConfiguration
    Private m_SessionFactory As ISessionFactory
    Private m_Session As SqlSession

    Public Sub New(ByVal environmentConfiguration As String)
        ConfigureNhibernate(environmentConfiguration)
        If (m_Session Is Nothing) Then
            m_Session = New SqlSession(m_SessionFactory)
        End If
    End Sub

    Public ReadOnly Property SessionFactory() As ISessionFactory
        Get
            Return m_SessionFactory
        End Get
    End Property

    Private Sub ConfigureNhibernate(ByVal configurationFileName As String)
        Try
            Dim assembly As Assembly = Me.GetType().Assembly
            Dim fullConfigurationName As String = String.Format("{0}.{1}", Me.GetType().Namespace, configurationFileName)
            Dim configuration As Configuration = New Configuration()
            configuration.Configure(assembly, fullConfigurationName)
            configuration.AddAssembly(assembly)
            m_SessionFactory = configuration.BuildSessionFactory()
        Catch ex As Exception
            Throw New RepositoryException("Problem with mapping.", ex.InnerException)
        End Try
    End Sub

End Class
