﻿Imports System.Collections.Generic
Imports Securex.FIT.Fitclient.Business.DataHolders
Imports Securex.FIT.Fitclient.Business
Imports Microsoft.VisualStudio.TestTools.UnitTesting
Imports Securex.FIT.Fitclient.Data.SQL

'''<summary>
'''This is a test class for SqlCategoryTest and is intended
'''to contain all SqlCategoryTest Unit Tests
'''</summary>
<TestClass()> _
Public Class SqlCategoryTest


    Private testContextInstance As TestContext

    '''<summary>
    '''Gets or sets the test context which provides
    '''information about and functionality for the current test run.
    '''</summary>
    Public Property TestContext() As TestContext
        Get
            Return testContextInstance
        End Get
        Set(ByVal value As TestContext)
            testContextInstance = Value
        End Set
    End Property

#Region "Additional test attributes"
    '
    'You can use the following additional attributes as you write your tests:
    '
    'Use ClassInitialize to run code before running the first test in the class
    '<ClassInitialize()>  _
    'Public Shared Sub MyClassInitialize(ByVal testContext As TestContext)
    'End Sub
    '
    'Use ClassCleanup to run code after all tests in a class have run
    '<ClassCleanup()>  _
    'Public Shared Sub MyClassCleanup()
    'End Sub
    '
    'Use TestInitialize to run code before running each test
    '<TestInitialize()>  _
    'Public Sub MyTestInitialize()
    'End Sub
    '
    'Use TestCleanup to run code after each test has run
    '<TestCleanup()>  _
    'Public Sub MyTestCleanup()
    'End Sub
    '
#End Region

    '''<summary>
    '''A test of SqlCategory
    '''</summary>
    <TestMethod()> _
    Public Sub Test_SqlCategory()
        'session
        Dim session As ISessionDao = Nothing
        '
        InitDatabase.Instance.Initialize()
        'actual
        Dim actual As IList(Of Category) = Nothing
        'expected
        Dim expected As Category = New Category()
        expected.Description = "testje"
        'sqlCategory instance
        Dim target As ICategoryDao = New SqlCategory()
        'session
        session = Facade.Instance.RepositoryFactory.CreateSession()
        'check if the collection is empty
        actual = target.GetAllCategories(session)
        Assert.IsTrue(actual.Count = 0, "collection contains no element")
        'save category
        target.Save(session, expected)
        session.CommitAndClose()
        Assert.IsTrue(True, "saved and committed")
        '
        'new session
        session = Facade.Instance.RepositoryFactory.CreateSession()
        '
        'check if the collection contains the saved category
        actual = target.GetAllCategories(session)
        Assert.IsTrue(actual.Count = 1, "collection contains 1 element")
        Assert.AreEqual(expected.Description, actual(0).Description, "the GetAllCategories collection contains the saved category")
        'check if the collection contains the saved category
        actual = target.GetCategoryByDescription(session, expected.Description)
        Assert.IsTrue(actual.Count = 1, "collection contains 1 element")
        Assert.AreEqual(expected.Description, actual(0).Description, "the GetCategoryByDescription collection contains the saved category")
        'check if the collection contains the saved category
        actual = target.GetCategoryById(session, actual(0).Id)
        Assert.IsTrue(actual.Count = 1, "collection contains 1 element")
        Assert.AreEqual(expected.Description, actual(0).Description, "the GetCategoryById collection contains the saved category")
        '
        'update category description
        expected = actual(0)
        expected.Description = "updated testje"
        'save category
        target.Save(session, expected)
        session.CommitAndClose()
        Assert.IsTrue(True, "saved and committed")
        '
        'new session
        session = Facade.Instance.RepositoryFactory.CreateSession()
        '
        'check if the collection contains the saved category
        actual = target.GetAllCategories(session)
        Assert.IsTrue(actual.Count = 1, "collection contains 1 element")
        Assert.AreEqual(expected.Description, actual(0).Description, "the GetAllCategories collection contains the saved category")
        'check if the collection contains the saved category
        actual = target.GetCategoryByDescription(session, expected.Description)
        Assert.IsTrue(actual.Count = 1, "collection contains 1 element")
        Assert.AreEqual(expected.Description, actual(0).Description, "the GetCategoryByDescription collection contains the saved category")
        'check if the collection contains the saved category
        actual = target.GetCategoryById(session, actual(0).Id)
        Assert.IsTrue(actual.Count = 1, "collection contains 1 element")
        Assert.AreEqual(expected.Description, actual(0).Description, "the GetCategoryById collection contains the saved category")
        '
        'delete category
        target.Remove(session, actual(0))
        session.CommitAndClose()
        Assert.IsTrue(True, "deleted")
        '
        'new session
        session = Facade.Instance.RepositoryFactory.CreateSession()
        '
        'check if the collection contains no elements
        actual = target.GetAllCategories(session)
        Assert.IsTrue(actual.Count = 0, "collection contains no element")
        'check if the collection contains the no elements
        actual = target.GetCategoryByDescription(session, expected.Description)
        Assert.IsTrue(actual.Count = 0, "collection contains no element")
    End Sub
End Class
