﻿Imports System.Collections.Generic
Imports Securex.FIT.Fitclient.Business.DataHolders
Imports Securex.FIT.Fitclient.Business
Imports Microsoft.VisualStudio.TestTools.UnitTesting
Imports Securex.FIT.Fitclient.Data.SQL

'''<summary>
'''This is a test class for SqlSubCategoryTest and is intended
'''to contain all SqlSubCategoryTest Unit Tests
'''</summary>
<TestClass()> _
Public Class SqlSubCategoryTest


    Private testContextInstance As TestContext

    '''<summary>
    '''Gets or sets the test context which provides
    '''information about and functionality for the current test run.
    '''</summary>
    Public Property TestContext() As TestContext
        Get
            Return testContextInstance
        End Get
        Set(ByVal value As TestContext)
            testContextInstance = Value
        End Set
    End Property

#Region "Additional test attributes"
    '
    'You can use the following additional attributes as you write your tests:
    '
    'Use ClassInitialize to run code before running the first test in the class
    '<ClassInitialize()>  _
    'Public Shared Sub MyClassInitialize(ByVal testContext As TestContext)
    'End Sub
    '
    'Use ClassCleanup to run code after all tests in a class have run
    '<ClassCleanup()>  _
    'Public Shared Sub MyClassCleanup()
    'End Sub
    '
    'Use TestInitialize to run code before running each test
    '<TestInitialize()>  _
    'Public Sub MyTestInitialize()
    'End Sub
    '
    'Use TestCleanup to run code after each test has run
    '<TestCleanup()>  _
    'Public Sub MyTestCleanup()
    'End Sub
    '
#End Region

    '''<summary>
    '''A test of SqlSubCategory
    '''</summary>
    <TestMethod()> _
    Public Sub Test_SqlSubCategory()
        Dim categoryId As Integer
        'session
        Dim session As ISessionDao = Nothing
        '
        InitDatabase.Instance.Initialize()
        'actual
        Dim actual As IList(Of SubCategory) = Nothing
        'expected
        Dim expected As SubCategory = New SubCategory()
        expected.Description = "testje"
        expected.Category = New Category() With {.Description = "test category"}
        'sqlCategory instance
        Dim target As ISubCategoryDao = New SqlSubCategory()
        'session
        session = Facade.Instance.RepositoryFactory.CreateSession()
        'save category
        target.Save(session, expected)
        session.CommitAndClose()
        Assert.IsTrue(True, "saved and committed")
        '
        'new session
        session = Facade.Instance.RepositoryFactory.CreateSession()
        '
        'check if the collection contains the saved subcategory
        actual = target.GetSubCategoryByDescription(session, expected.Description)
        Assert.IsTrue(actual.Count = 1, "collection contains 1 element")
        Assert.AreEqual(expected.Description, actual(0).Description, "the GetSubCategoryByDescription collection contains the saved subcategory")
        'check if the collection contains the saved subcategory
        actual = target.GetSubCategoryById(session, actual(0).Id)
        Assert.IsTrue(actual.Count = 1, "collection contains 1 element")
        Assert.AreEqual(expected.Description, actual(0).Description, "the GetSubCategoryById collection contains the saved subcategory")
        'check if the collection contains the saved subcategory
        categoryId = actual(0).Category.Id
        actual = target.GetCategoryByCategoryId(session, categoryId)
        Assert.IsTrue(actual.Count = 1, "collection contains 1 element")
        Assert.AreEqual(expected.Description, actual(0).Description, "the GetCategoryByCategoryId returned the subcategory based on the categoryId")
        Assert.AreEqual(expected.Category.Id, categoryId, "the GetCategoryByCategoryId returned the subcategory based on the categoryId")
        '
        'update subcategory description
        expected = actual(0)
        expected.Description = "updated testje"
        'save subcategory
        target.Save(session, expected)
        session.CommitAndClose()
        Assert.IsTrue(True, "saved and committed")
        '
        'new session
        session = Facade.Instance.RepositoryFactory.CreateSession()
        '
        'check if the collection contains the saved subcategory
        actual = target.GetSubCategoryByDescription(session, expected.Description)
        Assert.IsTrue(actual.Count = 1, "collection contains 1 element")
        Assert.AreEqual(expected.Description, actual(0).Description, "the GetSubCategoryByDescription collection contains the saved subcategory")
        'check if the collection contains the saved subcategory
        actual = target.GetSubCategoryById(session, actual(0).Id)
        Assert.IsTrue(actual.Count = 1, "collection contains 1 element")
        Assert.AreEqual(expected.Description, actual(0).Description, "the GetSubCategoryById collection contains the saved subcategory")
        'check if the collection contains the saved subcategory
        categoryId = actual(0).Category.Id
        actual = target.GetCategoryByCategoryId(session, categoryId)
        Assert.IsTrue(actual.Count = 1, "collection contains 1 element")
        Assert.AreEqual(expected.Description, actual(0).Description, "the GetCategoryByCategoryId returned the subcategory based on the categoryId")
        Assert.AreEqual(expected.Category.Id, categoryId, "the GetCategoryByCategoryId returned the subcategory based on the categoryId")
        '
        'delete category
        target.Remove(session, actual(0))
        session.CommitAndClose()
        Assert.IsTrue(True, "deleted")
        '
        'new session
        session = Facade.Instance.RepositoryFactory.CreateSession()
        '
        'check if the collection contains the no elements
        actual = target.GetSubCategoryByDescription(session, expected.Description)
        Assert.IsTrue(actual.Count = 0, "collection contains no element")
    End Sub

End Class
