(function (window, $) {

  // Please do not reuse this function.
  // [It's not somethink, someone to learn from.][1]
  // [1]: http://www.youtube.com/watch?v=gW1YOluDM3M
  var insertListItem = function ($el, data) {
    var user = data[0].user;
    var fst = user.first_name;
    var lst = user.last_name;
    var username = __(user.username);

    var $user = $(
      '<li data-username="' + username + '" class="data-username user">' +
        '<img src="' + __(user.avatar || BB.images.noAvatar) + '" /> ' +
        '<b>' + (fst && lst ? __(fst + ' ' + lst) : username) + '</b> ' +
        '<a href="#delete">Delete</a>' +
      '</li>');

    // Determine the position at which to insert the element such that
    // the list remains alphabetized.
    var cmp = $user.find('b').text().toLowerCase();
    var $next = $el.children('.data-username').first();
    while ($next.length && cmp > $next.text().trim().toLowerCase()) {
      $next = $next.next();
    }

    // Insert the element into the DOM.
    if ($next.length) $user.insertBefore($next);
    else              $user.appendTo($el);
  };

  // `autofocus` support for outdated browsers (Modernizr?)
  if (!('autofocus' in document.createElement('input'))) {
    BB.utils.guard('input[autofocus]', function ($el) { $el.focus(); });
  }

  // Follow buttons
  $('a.follow').click(function (event) {
    event.preventDefault();
    var
      $this = $(this),
      $followersCount = $('#followers-count'),
      className = $this.attr('class'),
      text = $this.text(),
      url = $this.attr('href');

    if ($this.hasClass('loading')) return;

    $this
      .addClass('loading')
      .removeClass('following')
      .text('updating');

    $.post(
      url,
      function (data) {
        var
          following = data.following,
          type = data.type;
        // anonymous user
        if (following === void 0) {
          // restore state before redirecting (don't break the "back" button)
          $this.attr('class', className).text(text);
          return (window.location.pathname = url);
        }
        // authenticated user
        $followersCount.text(data.followers);
        if (following) {
          $this.addClass('following').text('following').removeClass('loading');
          $this.parent().addClass('following');

          // register Google Analytics follow events
          if (type === 'repo') {
            BB.gaqPush(
              ['atl._trackPageview', '/repo/follow'],
              ['atl._trackEvent', 'Share', 'Follow Repo']
            );
          } else if (type === 'user') {
            BB.gaqPush(
              ['atl._trackPageview', '/user/follow'],
              ['atl._trackEvent', 'Share', 'Follow User']
            );
          }
        } else {
          $this
            .removeClass('following')
            .text('follow')
            .removeClass('loading')
            .parent()
              .removeClass('following');
        }
      }
    );
  });

  // OpenID
  BB.utils.guard('#sign-in,#signup,#associate-openid', function ($signin) {
    var
      $openId = $signin.find('.opensocial'),
      $openIdLink = $('.show-open-id>a'),
      $openIdSubmit = $openId.find('#openid_submit'),
      $selectedButton = $(),
      $selectedInput = $(),
      $standard = $signin.find('.standard'),
      $standardLink = $('.show-standard-signin>a'),
      cookieOptions = {expires: 365},
      openIdProviderHash = $.cookie('openid-provider');

    function select(button, input) {
      $selectedButton.add($selectedInput).removeClass('selected');
      $selectedButton = $(button).addClass('selected');
      $selectedInput = $(input).addClass('selected');
      $selectedInput.find('input').focus();
      $openIdSubmit.show();
      $.cookie('openid-provider', $selectedButton.attr('href'), cookieOptions);
    }

    if ($.cookie('login-method') === 'openid' || /\/openids\//.test(window.location.href)) {
      $standard.hide();
      $standardLink.parent().show();
      $openId.show();
      if (openIdProviderHash) {
        select('a[href="' + openIdProviderHash + '"]', openIdProviderHash);
      }
    }

    $openIdLink.click(function (event) {
      event.preventDefault();
      $standard.fadeOut('fast', function () {
        $openId.fadeIn('fast', function () {
          var openIdProviderHash = $.cookie('openid-provider');
          select('a[href="' + openIdProviderHash + '"]', openIdProviderHash);
        });
      });
      $openIdLink.parent().hide();
      $standardLink.parent().show();
      $.cookie('login-method', 'openid', cookieOptions);
    });

    $standardLink.click(function (event) {
      event.preventDefault();
      $openId.fadeOut('fast', function () { $standard.fadeIn('fast'); });
      $standardLink.parent().hide();
      $openIdLink.parent().show();
      $.cookie('login-method', 'standard', cookieOptions);
    });

    $openId.find('.badges a').click(function (event) {
      var $this = $(this), href = $this.attr('href');
      if ($this.data('url')) {
        select(this, href);
      } else {
        $.cookie('openid-provider', href, cookieOptions);
        window.location.assign(href);
      }
      event.preventDefault();
    });

    $openIdSubmit.click(function () {
      var id = $selectedInput.find('input').val();
      $('#openid_provider').val($selectedButton.data('url').replace('{id}', id));
      $('#openid_username').val(id);
      $('#openid_form').submit();
    });
  });

  // Fork at...
  $('#fp_sel').change(function () {
    if (this.value === 'specific') {
      $('#fp_specific').css('visibility', 'visible');
      $('#fp_specific_input').focus();
    } else {
      $('#fp_specific').css('visibility', 'hidden');
      $('#fp_specific_input').val(this.value);
    }
  });

  $('#repositories,#relevant-repos,#descendants,#trending-repositories,#featured-repositories').delegate('.followers .info-button-action a', 'click', BB.utils.enableFollowingLinks );

  // select/deselect all messages
  $('#notification-controls').find(':checkbox').click(function () {
    var checked = this.checked;
    $('#notifications').find(':checkbox').each(function () { this.checked = checked; });
  });

  // Wiki new page form
  BB.utils.guard('#wiki-nav-links', function ($wikiNavLinks) {
    var $form = $('#wiki-new-page-form');

    $wikiNavLinks.find('.new').show().find('a').click(function (event) {
      event.preventDefault();
      $form.toggle();
    });

    $form.find('input[type="submit"]').click(function (event) {
      event.preventDefault();
      var page = $('#wiki-new-page').val().replace(/^\/+|\/+$/g, '');
      if (page.length) window.location = window.location.pathname.replace(/wiki\/(.*)$/, 'wiki/edit/' + page);
    });
  });

  BB.utils.guard('#invitation-dialog', function ($invitation) {
    var
      $form = $invitation.find('form'),
      $email = $form.find('#id-email-address'),
      triggers = [
        '#repo-menu .share',
        '#repo-menu-links-mini .share',
        '#invitation-blurb .share',
        '#getting-started-tabs .share'
      ],
      invitationsEndpoint =
        BB.api.concat('invitations', BB.repo.owner.username, BB.repo.slug);

    $('#content').delegate(triggers.join(), 'click', function (event) {
      $invitation.dialog('open');
      event.preventDefault();
    });

    $invitation.dialog({
      // Options.
      autoOpen: false,
      modal: true,
      position: ['50%', 100],
      title: $invitation.attr('title'),
      width: 480,

      // Events.
      open: function () {
        $form.find('.success_.message_').hide();
        $form.find('.error_.message_').hide();
        $form.find('select').chosen();
        $email.val('');
      }
    });

    // For some reason (possibly a conflict with jQuery UI) the Chosen
    // drop-down gets stuck in an active state. Whenever it loses focus
    // we deactivate it ourselves to ensure the form remains navigable.
    $invitation.delegate('.chzn-single', 'blur', function (event) {
      $(this).prop({tabindex: 0}).parent().removeClass('chzn-container-active')
    });

    $form.submit(function (event) {
      var
        $form = $(this),
        email = $email.val(),
        $submit = $form.find(':submit');

      event.preventDefault();

      if ($submit.attr('disabled')) return;

      var messages = {
        200: email + ' has been invited.',
        400: 'Please enter a valid email address.',
        401: 'You are not authorized to send invitations for this repository.',
        404: 'This repository no longer exists.',
        409: email + ' has already been invited.',
        500: 'There was a problem processing your request (500 Internal Server Error).'
      };

      $submit.attr('disabled', 'disabled');
      var
        buttonText = $submit.val(),
        buttonWidth = $submit.outerWidth(),
        buttonTimeout = BB.delay(200, function () {
          $submit
            .addClass('disabled')
            .width(buttonWidth)
            .val('Sending...');
        });

      $.ajax({
        type: $form.attr('method'),
        // TODO Fix Endpoint to ignore empty string arguments.
        url: email ? invitationsEndpoint.toString(email)
                   : invitationsEndpoint.toString(),
        data: $form.serialize(),
        complete: function (xhr, status) {
          var
            $success = $form.find('.success_.message_').hide(),
            $error = $form.find('.error_.message_').hide();

          if (status === 'timeout') {
            $error
              .show()
              .find('h4').text('There was a problem connecting to the server.');
          } else if (messages.hasOwnProperty(xhr.status)) {
            var $message = xhr.status === 200 ? $success : $error;
            $message
              .show()
              .find('h4').text(messages[xhr.status]);
          }
          clearTimeout(buttonTimeout);
          $submit
            .removeAttr('disabled')
            .removeClass('disabled')
            .width('')
            .val(buttonText);
        },
        success: function (data, status, xhr) {
          if (xhr.status === 200) {
            // Make multiple email entry quicker by auto selecting the text.
            $email.select();
            BB.delay(1500, function () {
              // Auto close if not sending another invite.
              if (email === $email.val()) {
                $invitation.dialog('close');
              }
            });
            // Google Analytics.
            BB.gaqPush(['atl._trackEvent', 'Share', 'Invite user']);
          }
        }
      });
    });
  });

  $('#invitation-show-login').click(function (event) {
    event.preventDefault();
    $('#sign-in.invitation')
      .show()
      .find('input:visible:first').focus();
  });

  BB.utils.guard('#invitation-accepted', function ($invitation) {
    // Google Analytics.
    var kind = $invitation.val();
    BB.gaqPush(['atl._trackEvent', 'Share', 'Invitation Accepted', kind]);
  });

  $('#toggle-email-notifications').find('#id_email_notifications').click(function () {
    var $this = $(this), url = $this.parent('form').attr('action'), $label = $this.next('label');

    $this.css('visibility', 'hidden');
    $label.addClass('loading');

    $.get(url, function (data) {
      var toggle = data.toggle;
      $this.attr('checked', toggle);
      $this.css('visibility', 'inherit');
      $label.removeClass('loading');
    });
  });

  (function () {
    function enableAjaxFollow($repos) {
      var repoIds = BB.user.follows && BB.user.follows.repos;
      if (repoIds === void 0) return;

      $repos.find('.followers').addClass('followers-not-following');
      $repos.find('.info-button').removeClass('info-button-readonly');

      $(
        _.map(repoIds, function (id) { return '#id_repo_' + id; }).join()
      ).removeClass('followers-not-following').addClass('followers-following');
    }
    BB.utils.guard('#repositories', enableAjaxFollow);
    BB.utils.guard('#trending-repositories', enableAjaxFollow);
    BB.utils.guard('#featured-repositories', enableAjaxFollow);
    BB.utils.guard('#descendants', enableAjaxFollow);
  }());

  // Very ugly hack to suppress multiple email confirm messages (BB-1026).
  BB.utils.guard('#pending-address', function ($pendingAddressMessage) {
    if ($('#header-messages').find('.confirmation-successful').length) {
      $pendingAddressMessage.hide();
    }
  });

  $('a.revoke').click(function (event) {
    if (!confirm('Are you sure you want to revoke your access to this repository?')) {
      event.preventDefault();
    }
  });

  // styling hook for "lingering" hover effects
  var $dropdowns = $('.inertial-hover').each(function () {
    var timeoutId = null;
    $(this).bind({
      mouseenter: function () {
        // Preclude multiple drop-downs from being visible at once.
        $dropdowns.removeClass('hovering');
        if (timeoutId !== null) {
          window.clearTimeout(timeoutId);
          timeoutId = null;
        }
        $(this).addClass('hovering');
      },
      mouseleave: function () {
        timeoutId = BB.delay(500, function () {
          if (timeoutId !== null) $(this).removeClass('hovering');
        }.bind(this));
      }
    });
  });

  // HTTPS/SSH toggle
  BB.utils.guard('#repo-desc-cloneinfo', function ($el) {
    $el.attr('class', BB.user.isSshEnabled ? 'ssh' : 'https');
    _.each(['https', 'ssh'], function (protocol) {
      $el.find('a.' + protocol).click(function (event) {
        $el.attr('class', protocol);
        event.preventDefault();
      });
    });
  });

  BB.utils.guard('#uploadform', function($f) {
    var xhr_url = $f.attr("action"),
      $mf = $("#new-download").hide(),
      $w = $('#captcha-wrong').hide();
    $f.submit(function() {
      $.getJSON(xhr_url, $(this).serialize(), function(data) {
        if (data.status == 'success') {
          $mf.find('[name="Policy"]').val(data.policy);
          $mf.find('[name="Signature"]').val(data.signature);
          $mf.show();
          $f.hide();
        } else if (data.status == 'fail') {
          $w.show();
        }
      });
      return false;
    });
  });

  $('#embed-link')
    .click(
      function (event) {
        var
          $this = $(this),
          $label = $('<label for="embedded-link">embed code:</label>'),
          $input = $('<input type="text" id="embedded-link" />');

        $input.val('<script src="' + $this.attr('href') + '"></script>');
        $input.replaceAll($this).before($label).select();
        event.preventDefault();
      }
    );

  // Little js to animate activation of the searchbox
  $('#searchbox').bind({
    focusin: function () {
      $(this).animate({opacity: 1, width: 170})
    },
    focusout: function () {
      $(this).animate({opacity: 0.6, width: 117})
    }
  })

  // Autocomplete for repo navigation
  $('#searchbox').autocomplete({
    minLength: 3,
    source: '/xhr/repositories',
    extractTerms: function (val) {
      var idx = val.indexOf('/')
      return idx >= 0 ? [val.substr(0, idx), val.substr(idx + 1)] : [val]
    },
    select: function (event, ui) {
      window.location = '/' + ui.item.value
    },
    // Override and stop the event so the text in the input will not be
    // replaced.
    focus: function (event, ui) {
      event.preventDefault()
    }
  })

  // JSUDiff
  jQuery(function ($) {
    $('.jsudiff')
      .udiff(
        function (line, key) {
          var
            id, name,
            num = line.number[key];

          if (num) {
            name = line.file.name;
            id = 'chg_';
            id += key === 'now' ? name.now + '_new' : name.then + '_old';
            id += 'line' + num;
            this
              .attr('id', id)
              .html('<a href="#' + id + '">' + num + '</a>');
          }
        }
      );
  });

}(this, jQuery));

// Floating sidebar positioning.
BB.utils.guard('#sidebar', function ($sidebar) {
  var offsetTop = $sidebar.offset().top;
  // Take into account the sidebar's top margin.
  offsetTop -= parseInt($sidebar.css('margin-top'), 10);
  var $window = $(window).scroll(function () {
    $sidebar.toggleClass('fixed', $window.scrollTop() > offsetTop);
  });

  if ($.browser.webkit) {
    // Need to force a repaint of the sidebar in Chrome.
    var background = $sidebar.css('background');
    $sidebar.delegate('a', 'click', function () {
      $sidebar.css('background', '#fefefe');
      BB.delay(function () {
        $sidebar.css('background', background);
      });
    });
  }
});

BB.initialize.register(BB.utils.placeholder, BB.localize);

// Repeat every 60 seconds.
window.setInterval(BB.localize, 60 * 1000);

// Filtering dropdowns
$('.dropdown-filter').each(function() {
  var $input = $(this), $revs = $input.parent('li').siblings('.comprev'), moving = false, cid = undefined;
  var maybeclear = function(t) { if (!t.value.trim()) $revs.removeClass('selected').show() };

  $input.bind('search', function() { maybeclear(this) });
  $input.bind('blur', function() { this.value = ''; maybeclear(this) });

  $input.keydown(function(ev) {
    switch(ev.which) {
      case $.ui.keyCode.DOWN:
      case $.ui.keyCode.UP:
        var $visrevs = $revs.filter(':visible'), moving = ev.which;
        var $sel = $visrevs.filter('.selected');

        var idx = $visrevs.index($sel),
            step = -1+(ev.which === $.ui.keyCode.DOWN)*2;

        if (~idx) {
          $sel.removeClass('selected') &&
            $($visrevs[(idx+step)]).addClass('selected');
        } else {
          $($visrevs[step>-1?0:$visrevs.length-1]).addClass('selected');
        }

        $input.parents('ul:first').scrollTop((idx-9)*27);

        cid = setInterval(function() {
          if (moving) $input.trigger({type: 'keypress', which: moving});
        }, 200);

        break;
    }
  });

  $input.keyup(function(ev) {
    switch(ev.which) {
      case $.ui.keyCode.ESCAPE:
        maybeclear(this);
        break;
      case $.ui.keyCode.DOWN:
      case $.ui.keyCode.UP:
        if (cid) clearInterval(cid);
        moving = false;
        break;
      case $.ui.keyCode.ENTER:
        window.location.href = $revs.filter(':visible .selected').find('a:first').attr('href');
        break;
      default:
        var term = $input.val().trim().toLowerCase()

        if (!term) return $revs.show();

        $revs.hide();

        $revs.each(function(i) {
          var $rev = $(this);
            if (~$rev.find('a:first').text().toLowerCase().indexOf(term)) $rev.show();
        });

        break;
    }
  });
});
